/*
QuestionMark crea quiz interattivi con estensione .html
    Copyright (C) 2013  Vittorio Tornar vtornar@libero.it

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package application;

import javafx.scene.control.TextArea;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javafx.application.Application;
import javafx.application.HostServices;
import javafx.application.Platform;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.input.MouseEvent;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.ColorPicker;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Hyperlink;
import javafx.scene.control.Label;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuBar;
import javafx.scene.control.MenuItem;
import javafx.scene.control.RadioButton;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.Tab;
import javafx.scene.control.TabPane;
import javafx.scene.control.TabPane.TabClosingPolicy;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleGroup;
import javafx.scene.control.Tooltip;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.RowConstraints;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.text.Text;
import javafx.scene.text.TextFlow;
import javafx.scene.layout.GridPane;
import javafx.stage.FileChooser;
import javafx.stage.FileChooser.ExtensionFilter;
import javafx.stage.Screen;
import javafx.stage.Stage;
 
public class QuestionMarkFX extends Application 
{   private String bcolor;								//BACKCOLOR
	private String b;	
	private String fcolor;								//FONTCOLOR
	private String f;
	private boolean check;								//UGUALI PER TUTTI
	private ChoiceBox<String> fontType;
	private ChoiceBox<String> fontSize;
	private TextField nomeFile;
	private TextArea tp;
	private TextArea messages;
	private TextField intest;
	private TabPane htpane;
	private int vectorcvf;								//VF
	private Vector<StringBuffer> domandevf;
	private File fvf;
	private TextArea domandavf;
	private StringBuffer[] dvf;
	private int vectorcrm;								//RM
	private Vector<StringBuffer> domanderm;
	private StringBuffer[] drm;
	private File frm;
	private TextArea domandarm;
	private TextArea corretta;
	private TextArea errata1;
	private TextArea errata2;
	private TextArea errata3;
	private int vectorccf;								//CF
	private Vector<StringBuffer> domandecf;
	private StringBuffer[] dcf;
	private File fcf;
	private TextArea cfta;
	private int catCount;								//RT
	private String numbers;
	private int vectorcrt;
	private Vector<StringBuffer> domandert;
	private File frt;
	private StringBuffer[] drt;
	private TextArea rtta;
	private int vectorccr;								//CR
	private Vector<StringBuffer> domandecr;
	private Vector<StringBuffer> rispostecr;
	private StringBuffer[] dcr;
	private StringBuffer[] rcr;
	private File fcr;
	private TextArea domandacr;
	private TextArea rispostacr;
	private String[] order;								//RF
	private File frf;
	private Vector<StringBuffer> domanderf;
	private Vector<StringBuffer> risposterf;
	private int vectorcrf;
	private StringBuffer[] drf;
	private StringBuffer[] rrf;
	private TextArea domandarf;
	private TextArea rispostarf;
	private Button ch_image;							//IMAGEMAP
	private TextArea coords;
	private AnchorPane apimg;
	private ScrollPane scroll;
	
		
	public static void main(String[] args)
	{	Application.launch(args);
	}	
    @Override
    public void start(Stage primaryStage) throws FileNotFoundException, MalformedURLException 
    {   primaryStage.setTitle("QuestionMark");
	    GridPane root = new GridPane();
	    root.getStyleClass().add("main-root");
	    final int numCols = 20 ;
        final int numRows = 20 ;
        for (int i = 0; i < numCols; i++) 
        {   ColumnConstraints colConst = new ColumnConstraints();
            colConst.setPercentWidth(100.0 / numCols);
            root.getColumnConstraints().add(colConst);
        }
        for (int i = 0; i < numRows; i++) 
        {   RowConstraints rowConst = new RowConstraints();
            rowConst.setPercentHeight(100.0 / numRows);
            root.getRowConstraints().add(rowConst);         
        }          
        //BOTTONE SFONDO        
        bcolor = "";
        Button backColor = new Button("colore sfondo");        
        backColor.setOnAction( actionEvent -> 
        {   Stage k = new Stage();
        	bcolorPicker q = new bcolorPicker();
        	q.start(k);            
        } ); 
        tp = new TextArea(""); tp.setPromptText("html");
        tp.setPrefSize(800,600);
        tp.setWrapText(true);  
        htpane = new TabPane();
        htpane.setTabClosingPolicy(TabClosingPolicy.UNAVAILABLE);
        Tab tatab = new Tab("html");
        tatab.setContent(tp);
        scroll = new ScrollPane();
        Tab imgtab = new Tab("img");
        imgtab.setContent(scroll);        
        htpane.getTabs().addAll(tatab,imgtab);        
        CheckBox quizMedia = new CheckBox("media?");
        String qmttip = "immagini e audio per risposte corrette ed errate";
        Tooltip qmedia = new Tooltip(qmttip);
        quizMedia.setTooltip(qmedia);
        messages = new TextArea("");messages.setPromptText("QuestionMark");
        messages.setEditable(false);
        nomeFile = new TextField("");nomeFile.setPromptText("nome file");
        MenuBar menuBar = new MenuBar();
        ObservableList <String> fontTypes = FXCollections.observableArrayList();
        fontTypes.addAll("scegli un font","'American Typewriter', Serif","'Andale Mono', Monospace","'Apple Chancery', Cursive"
		,"Bookman, Serif","'Bradley Hand', Cursive","'Brush Script MT', Cursive","Arial, Sans-Serif"
		,"‘Arial Black’, Sans-Serif","'Arial Narrow', Sans-Serif","Avenir, Sans-Serif","'Comic Sans MS', Cursive"
		,"Courier, Monospace","'Courier New', Monospace","Didot, Serif","FreeMono, Monospace","Georgia, Serif"
		,"'Gill Sans', Serif","Impact, Fantasy","Inconsolata, Monospace","'Lucida Console', Monospace"
		,"'Marker Felt', Fantasy","Monaco, Monospace","Monofur, Monospace","'New Century Schoolbook', Serif"
		,"'Noto Sans', Sans-Serif","Optima, Sans-Serif","Palatino, Serif","'Stencil Std', Fantasy","Times, Serif"
		,"'Times New Roman', Serif","'Trebuchet MS', Serif","Verdana, Sans-Serif");
		fontType = new ChoiceBox<String>(fontTypes);
		fontType.getSelectionModel().select(0);
		ObservableList <String> fontSizes = FXCollections.observableArrayList();
		fontSizes.addAll("dim. testo","small","medium","large","x-large","xx-large");
		fontSize = new ChoiceBox<String>(fontSizes);
		fontSize.getSelectionModel().select(0);
		fcolor = "";
		Button fontColor = new Button("colore font");
		fontColor.setOnAction( actionEvent -> 
        {   fontColor.arm();
        	Stage k = new Stage();
        	fcolorPicker q = new fcolorPicker();
            q.start(k);
        } );
		intest = new TextField("");intest.setPromptText("intestazione");
		ChoiceBox<String> titolo = new ChoiceBox<String>();
		titolo.getItems().addAll("titolo","grande","molto grande","grandissimo");
		String tttip = "seleziona la parola che deve diventare un titolo, poi scegline la dimensione";
		Tooltip tittp = new Tooltip(tttip);
		titolo.setTooltip(tittp);
		titolo.getSelectionModel().select(0);
		titolo.setOnAction(new EventHandler<ActionEvent>() 								//TITOLO HANDLER
		{   String babba;
			@Override
            public void handle(ActionEvent event) 
        	{	if (tp.getSelectedText() == null || tp.getSelectedText() == "")
				{	tp.setTooltip(new Tooltip("Attenaione! Non hai selezionato testo!"));
					titolo.getSelectionModel().select(0);
					return;				
				}				
        		else 
				{	babba = tp.getSelectedText();
					{	if (titolo.getValue().equals("grande"))
						{	tp.replaceSelection("\n<h3 style=\"text-align:center; font-weight: bold\">" + babba + "</h3>\n");					
						} 
						else if (titolo.getValue().equals("molto grande"))
						{	tp.replaceSelection("\n<h2 style=\"text-align:center; font-weight: bold\">" + babba + "</h2>\n");					
						}
						else if (titolo.getValue().equals("grandissimo"))
						{	tp.replaceSelection("\n<h1 style=\"text-align:center; font-weight: bold\">" + babba + "</h1>\n");					
						}						
					}					
				}
        	titolo.getSelectionModel().select(0);
        	}
		});
		ObservableList <String> styles = FXCollections.observableArrayList();
		styles.addAll("stile","grassetto","sottolineato","italico","a capo","sub","sup");
		ChoiceBox<String> stile = new ChoiceBox<String>(styles);
		String sttip = "seleziona la parola cui cambiare lo stile poi scegline uno";
		Tooltip stiletp = new Tooltip(sttip);
		stile.setTooltip(stiletp);
		stile.getSelectionModel().select(0);
		stile.setOnAction(new EventHandler<ActionEvent>() 								//STILE HANDLER
		{   @Override
            public void handle(ActionEvent event) 
        	{	if (tp.getSelectedText()==null || tp.getSelectedText() == "" || tp.getSelectedText().length()==0)
	        	{	stile.getSelectionModel().select(0);
	        		tp.setTooltip(new Tooltip("Attenzione! Non hai selezionato testo!"));
        			return;
	        	}
        		else
        		{	if (stile.getValue().equals("grassetto"))
					{	tp.replaceSelection("<b>" + tp.getSelectedText() + "</b>");							
					}
					else if (stile.getValue().equals("italico"))
					{	tp.replaceSelection("<i>" + tp.getSelectedText() + "</i>");					
					}
					else if (stile.getValue().equals("sottolineato"))
					{	tp.replaceSelection("<u>" + tp.getSelectedText() + "</u>");					
					}
					else if (stile.getValue().equals("a capo"))
					{	tp.replaceSelection(tp.getSelectedText() + "<br>");					
					}
					else if (stile.getValue().equals("sub"))
					{	tp.replaceSelection("<sub>" + tp.getSelectedText() + "</sub>");					
					}
					else if (stile.getValue().equals("sup"))
					{	tp.replaceSelection("<sup>" + tp.getSelectedText() + "</sup>");					
					}
	    		}       		
        		stile.getSelectionModel().select(0);
        		return;
        	}			
		});
        Menu file = new Menu("File");
        
        //MENU APRI
        
        MenuItem apri = new MenuItem("Apri");
         apri.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{   FileChooser fileChooser = new FileChooser();
	         	fileChooser.setTitle("apri un file");
	         	fileChooser.getExtensionFilters().addAll(
         	        new ExtensionFilter("text files", "*.txt"),
         	        new ExtensionFilter("web files", "*.html", ".htm"),
         	        new ExtensionFilter("all files", "*.*"));
	         	File chose = fileChooser.showOpenDialog(primaryStage);
	         	tp.setText("");
	         	if (chose != null) 
	         	{	try {	FileInputStream fstream = new FileInputStream(chose);
			        		DataInputStream in = new DataInputStream(fstream);
			        		BufferedReader br = new BufferedReader(new InputStreamReader(in));
			        		String strLine = "";
			        		while ((strLine = br.readLine())!= null)
			        		{	tp.setText(tp.getText()+"\n"+strLine);
			        		}
			        		br.close();
						}
					catch 	(Exception ex) 
						{	System.out.println(ex.toString());
							messages.setText(ex.toString());
						}
	         	}
         	}
         });  
         
         //MENU SALVA
         
         MenuItem salva = new MenuItem("Salva");
         salva.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{   if (nomeFile.getText()==null || nomeFile.getText().length()==0)
	    	 	{	showAlert("Scegli un nome file!");
		     	}  
         		else if (tp.getText()==null || tp.getText().length()==0)
         		{	showAlert("L' area di testo non contiene testo!");       			
         		}
         		else
         		{	String currentD = System.getProperty("user.dir");
         			String p=nomeFile.getText()+".html";
         			String s = tp.getText().replaceAll("à","&#224").replaceAll("è","&#232").replaceAll("ì","&#236").replaceAll("ò","&#242").replaceAll("ù","&#249").replaceAll("È", "&#200");
         			try
					{	FileWriter scoutFW = new FileWriter(currentD+"/quiz/"+nomeFile.getText()+"/"+ p);
						BufferedWriter scoutBW = new BufferedWriter(scoutFW);
						PrintWriter scoutPW = new PrintWriter(scoutBW);
						scoutPW.print(s);
						scoutPW.close();
					}
					catch 	(Exception ex) 
					{	System.out.println(ex.toString());
						messages.setText(ex.toString());
					}	
         		}
         	 }
         });  
         
         //MENU SALVAAPRI
         
         MenuItem salvaapri = new MenuItem("Salva e apri");
         salvaapri.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{      if (nomeFile.getText().length()==0 || nomeFile.getText().indexOf("nome File")!=-1)
		    	 	{	showAlert("Scegli un nome file!"); 		         	
			     	}  
	         		else if (tp.getText().length()==0 || tp.getText().indexOf("</html>")==-1)
	         		{	showAlert("L' area di testo non contiene codice!");       			
	         		}
	         		else if (nomeFile.getText().length()>0 && nomeFile.getText().indexOf("nome File")==-1)
	         		{	String currentD = System.getProperty("user.dir")+"/quiz/"+nomeFile.getText()+"/";
	         			String p = nomeFile.getText()+".html";
	         			String s = tp.getText().replaceAll("à","&#224").replaceAll("è","&#232").replaceAll("ì","&#236").replaceAll("ò","&#242").replaceAll("ù","&#249").replaceAll("È", "&#200");
	         			try
						{	FileWriter scoutFW = new FileWriter(currentD+"/"+ p);
							BufferedWriter scoutBW = new BufferedWriter(scoutFW);
							PrintWriter scoutPW = new PrintWriter(scoutBW);
							scoutPW.print(s);
							scoutPW.close();
							HostServices billo = getHostServices();
							billo.showDocument(currentD+"/"+p);
						}
						catch 	(Exception ex) 
						{	System.out.println(ex.toString());
							messages.setText(ex.toString());
						}	
	         		}         	 
             }
         });  
         
         //MENU ESCI
         
         MenuItem esci = new MenuItem("Esci");
         esci.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	Platform.exit();         	
         	}
         });  
        file.getItems().add(apri);
        file.getItems().add(salva);
        file.getItems().add(salvaapri);
        file.getItems().add(esci);
        Menu modifica = new Menu("Modifica");
        MenuItem tutto = new MenuItem("Seleziona tutto");
         tutto.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tp.requestFocus();
        	 	tp.selectAll();         	
         	}
         });  
         MenuItem niente = new MenuItem("Deseleziona tutto");
         niente.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tp.requestFocus();
        	 	tp.extendSelection(0);         	
         	}
         });  
         MenuItem copia = new MenuItem("Copia");
         copia.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getSelectedText()=="" || tp.getSelectedText()==null)
         		showAlert("non hai selezionato il testo da copiare");
         		else
        	 	tp.copy();         	
         	}
         });  
         MenuItem taglia = new MenuItem("Taglia");
         taglia.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getSelectedText()=="" || tp.getSelectedText()==null)
         		showAlert("non hai selezionato il testo da tagliare");
         		else
        	 	tp.cut();         	
         	}
         });  
         MenuItem incolla = new MenuItem("Incolla");
         incolla.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tp.paste();         	
         	}
         });  
        
        modifica.getItems().add(copia);
        modifica.getItems().add(taglia);
        modifica.getItems().add(incolla);
        modifica.getItems().add(tutto);
        modifica.getItems().add(niente);
        
        // MENU NUOVO 
        
        TabPane tab = new TabPane();  				//TabPane declaration
        tab.getStyleClass().add("mbar");
        Menu nuovo = new Menu("Nuovo");
        MenuItem vf = new MenuItem("Vero o falso");
         vf.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tab.getSelectionModel().select(1);         	
         	}
         });  
         MenuItem rm = new MenuItem("Risposta multipla");
         rm.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tab.getSelectionModel().select(2);         	
         	}
         });  
         MenuItem cf = new MenuItem("Completa frasi");
         cf.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tab.getSelectionModel().select(3);         	
         	}
         });  
         MenuItem rt = new MenuItem("Riconosci termine");
         rt.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tab.getSelectionModel().select(4);         	
         	}
         });  
         MenuItem cr = new MenuItem("Incrocio");
         cr.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tab.getSelectionModel().select(5);         	
         	}
         });  
         MenuItem rf = new MenuItem("Riordina frase");
         rf.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	tab.getSelectionModel().select(6);         	
         	}
         });  
        nuovo.getItems().add(vf);
        nuovo.getItems().add(rm);
        nuovo.getItems().add(cf);
        nuovo.getItems().add(rt);
        nuovo.getItems().add(cr);
        nuovo.getItems().add(rf);
        Menu media = new Menu("Media");
        MenuItem textTag = new MenuItem("Testo");
        textTag.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
         		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
				else
				{	String st=tp.getText();
			    	String divVF="<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">";
			    	String divRT="<td id=\"central\" colspan=\"3\">";
			    	String h =""+'\n'+'\n'+'\n'+"---->> INCOLLA IL TESTO QUI <<----"+'\n'+'\n'+'\n';
			    	String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">";
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"textdiv\" style=\"position:absolute;top:30%;left:1%;width:47%;height:50%;padding:5px;font-style:italic;overflow:auto;border-style:dotted;border-width:1px;border-color:gray\">"+
							h +"</div><div id=\"central\" style=\"position:absolute;top:30%;left:50%;width:47%;height:50%;padding:5px;overflow:auto\">";
						String added=m.replaceFirst(s);
						tp.setText(added);
						messages.setText("Incollare il testo nello spazio indicato, al posto del testo incolla qui e di tutte le frecce.");
					}
					else if (m2.find())
					{	String s = "<td id=\"textTd\"  style=\"font-style:italic;border-style:solid;border-width:1px;border-color:#cdcdcd\">"+h+"</td><td id=\"central\" colspan=\"2\">";
						String added=m.replaceFirst(s);
						tp.setText(added);
						messages.setText("Incollare il testo nello spazio indicato, al posto del testo incolla qui e di tutte le frecce.");
					}					
					else if (m3.find())
					{	String s = "<div id=\"textdiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; border: 1px solid gray; padding: 10px\">"+
							h+"</div><div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto; text-align:center; \">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere testo. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere testo. I quiz CR non ne accettano.");
					}
				}			
         	}
         });  
         MenuItem imgTag = new MenuItem("Immagine");
         imgTag.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona l' immagine");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file immagine", "*.jpg","*.png","*.JPG","*.jpeg","*.JPEG","*.gif"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName +"/"+folderName +"/", chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "<img src=\"" + folderName + "/" + chose.getName() + "\" width=\"100%\">";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}					
				    String st=tp.getText();
				    String divVF = "<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">";
					String divRT = "<td id=\"central\" colspan=\"3\">";
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">"; 
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"imgdiv\" style=\"position: absolute; top: 30%; left: 1%; width: 48%; height: 50%; padding: 5px; overflow: auto; text-align: center\">"+
							h+"</div><div id = \"central\" style=\"position: absolute; top: 30%; left: 50%; width: 48%; height: 50%; padding: 5px; overflow: auto\">";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}				
					else if (m2.find())
					{	String s = "<td id=\"imgTd\" class=\"borders\">"+h+"</td><td id=\"central\" colspan=\"2\">";
						String added=m2.replaceFirst(s);
						tp.setText(added);
					}
					
					else if (m3.find())
					{	String s = "<div id=\"imgdiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">\n"+
							h+"\n</div>\n<div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto; text-align: center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere immagine. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere immagine. I quiz CR non ne accettano.");
					}
				}         	
         	}
         });  
         MenuItem movieTag = new MenuItem("Filmato");
         movieTag.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
				else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona il video");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file video", "*.avi","*.mp4","*.mkv","*.divx","*.3gp","*.webm","*.mpeg4","*.mov"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName+"/"+folderName +"/",chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "<video width=\"100%\" controls autoplay>\n" + 
								"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"video/mp4\">\n" + 
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"video/ogg\">\n" +
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"video/webm\">\n" +								
								"  Your browser doesn' t support HTML video.\n" + 
								"</video>\n";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}					
					String st=tp.getText();
				    String divVF="<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n";
					String divRT="<td id=\"central\" colspan=\"3\">\n";	
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">";
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"videodiv\" style=\"position:absolute;top:30%;left:1%;width:48%;height:50%;padding:5px;overflow:auto;text-align: center\">\n"+
							h+"</div>\n<div id=\"central\" style=\"position:absolute;top:30%;left:50%;width:48%;height:50%;padding:5px;overflow:auto\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}
					else if (m2.find())
					{	String s = "<td id=\"videoTd\">\n"+h+"\n</td>\n<td id=\"central\" colspan=\"2\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}					
					else if (m3.find())
					{	String s = "<div id=\"videodiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">"+
							h+"</div><div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto;text-align:center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere video. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere video. I quiz CR non ne accettano.");
					}
				}         	
         	}
         });           
         MenuItem audioTag = new MenuItem("File audio");
         audioTag.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona il file audio");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file audio", "*.mp3","*.wav","*.pcm","*.ogg","*.flac","*.wma"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName+"/"+folderName +"/",chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "<br><br><br><audio controls autoplay>\n" + 
								"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"audio/mpeg\">\n" + 
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"audio/ogg\">\n" +
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"audio/wav\">\n" +								
								"  Your browser doesn' t support HTML audio.\n" + 
								"</audio>\n";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}
					String st=tp.getText();
				    String divVF="<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n";
					String divRT="<td id=\"central\" colspan=\"3\">\n";	
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">";
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"videodiv\" style=\"position:absolute;top:30%;left:1%;width:48%;height:50%;padding:5px;overflow:auto;text-align: center\">\n"+
							h+"</div>\n<div id=\"central\" style=\"position:absolute;top:30%;left:50%;width:48%;height:50%;padding:5px;overflow:auto\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}
					else if (m2.find())
					{	String s = "<td id=\"videoTd\">\n"+h+"\n</td>\n<td id=\"central\" colspan=\"2\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}					
					else if (m3.find())
					{	String s = "<div id=\"videodiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">"+
							h+"</div><div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto;text-align:center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere file audio. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere file audio. I quiz CR non ne accettano.");
					}
				}         	
         	}
         });  
         MenuItem pdf = new MenuItem("Documento pdf");
         pdf.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
				else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona il file pdf");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file pdf", "*.pdf"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName+"/"+folderName +"/",chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "\n<iframe src=\"" + folderName + "/" + chose.getName() + "\" title = \"a pdf doc\" width = \"100%\" height = \"100%\" allowfullscreen></iframe>";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}				
				    String st=tp.getText();
				    String divVF="<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n";
					String divRT="<td id=\"central\" colspan=\"3\">\n";	
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">";
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"videodiv\" style=\"position:absolute;top:30%;left:1%;width:48%;height:50%;padding:5px;overflow:auto;text-align: center\">\n"+
							h+"</div>\n<div id=\"central\" style=\"position:absolute;top:30%;left:50%;width:48%;height:50%;padding:5px;overflow:auto\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}
					else if (m2.find())
					{	String s = "<td id=\"videoTd\">\n"+h+"\n</td>\n<td id=\"central\" colspan=\"2\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}					
					else if (m3.find())
					{	String s = "<div id=\"videodiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">"+
							h+"</div><div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto;text-align:center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere il documento. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere il documento. I quiz CR non ne accettano.");
					}
				}         	
         	}
         });  
         MenuItem imgText = new MenuItem("Immagine e didascalia");
         imgText.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona l' immagine");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file immagine", "*.jpg","*.png","*.JPG","*.jpeg","*.JPEG","*.gif"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName +"/"+folderName +"/", chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "\n\n\n--->> INCOLLA IL TESTO QUI <<---\n\n\n<img src=\""+folderName+"/"+chose.getName()+"\" width=\"100%\">\n\n\n--->> OPPURE QUI <<---\n\n\n";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}					
					String st=tp.getText();
				    String divVF = "<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">";
					String divRT = "<td id=\"central\" colspan=\"3\">";
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">"; 
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"imgdiv\" style=\"position: absolute; top: 30%; left: 1%; width: 48%; height: 50%; padding: 5px; overflow: auto; text-align: center\">"+
							h+"</div><div id = \"central\" style=\"position: absolute; top: 30%; left: 50%; width: 48%; height: 50%; padding: 5px; overflow: auto\">";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}				
					else if (m2.find())
					{	String s = "<td id=\"imgTd\" class=\"borders\">"+h+"</td><td id=\"central\" colspan=\"2\">";
						String added=m2.replaceFirst(s);
						tp.setText(added);
					}
					
					else if (m3.find())
					{	String s = "<div id=\"imgdiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">\n"+
							h+"\n</div>\n<div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto; text-align: center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere immagine. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere immagine. I quiz CR non ne accettano.");
					}
				}         	
         	}
         });  
         MenuItem movieText = new MenuItem("Filmato e didascalia");
         movieText.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
				else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona il video");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file video", "*.avi","*.mp4","*.mkv","*.divx","*.3gp","*.webm","*.mpeg4","*.mov"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName+"/"+folderName +"/",chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "\n\n\n--->> INCOLLA IL TESTO QUI <<---\n\n\n<video width=\"100%\" controls autoplay>\n" + 
								"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"video/mp4\">\n" + 
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"video/ogg\">\n" +
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"video/webm\">\n" +								
								"  Your browser doesn' t support HTML video.\n" + 
								"</video>\n\n\n--->> OPPURE QUI <<---\n\n\n";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}
					String st=tp.getText();
				    String divVF="<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n";
					String divRT="<td id=\"central\" colspan=\"3\">\n";	
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">";
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"videodiv\" style=\"position:absolute;top:30%;left:1%;width:48%;height:50%;padding:5px;overflow:auto;text-align: center\">\n"+
							h+"</div>\n<div id=\"central\" style=\"position:absolute;top:30%;left:50%;width:48%;height:50%;padding:5px;overflow:auto\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}
					else if (m2.find())
					{	String s = "<td id=\"videoTd\">\n"+h+"\n</td>\n<td id=\"central\" colspan=\"2\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}					
					else if (m3.find())
					{	String s = "<div id=\"videodiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">"+
							h+"</div><div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto;text-align:center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere video. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere video. I quiz CR non ne accettano.");
					}
				}         	
         	}
         });  
         MenuItem audioText = new MenuItem("Audio e didascalia");
         audioText.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	if (tp.getText() == null || tp.getText().length() == 0)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
	     		else if (tp.getText().indexOf("html") != -1 && tp.getText().length() == 4)
				{	showAlert("Attenzione! L' area di testo è vuota!");
				}
				else
				{	String folderName = nomeFile.getText().trim();
					String currentD = System.getProperty("user.dir");
					FileChooser fileChooser = new FileChooser();
		         	fileChooser.setTitle("seleziona il file audio");
		         	File f = new File(currentD);
		         	fileChooser.setInitialDirectory(f);
		         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file audio", "*.mp3","*.wav","*.pcm","*.ogg","*.flac","*.wma"));		         	
					String h = "";
					try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						FileInputStream in1 = new FileInputStream(chose);
				        /* Apri uno stream di output */
				        FileOutputStream out1 = new FileOutputStream(new File(currentD+"/quiz/"+folderName+"/"+folderName +"/",chose.getName()));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        h = "\n<br><br>\n\n\n--->> INCOLLA IL TESTO QUI <<---\n\n\n<audio controls autoplay>\n" + 
								"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"audio/mpeg\">\n" + 
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"audio/ogg\">\n" +
				        		"  <source src=\"" + folderName + "/" + chose.getName() + "\" type=\"audio/wav\">\n" +								
								"  Your browser doesn' t support HTML audio.\n" + 
								"</audio>\n\n\n--->> OPPURE QUI <<---\n\n\n";
					}
					catch (Exception b)
					{	System.out.println(b.toString());					
					}					
				    String st=tp.getText();
				    String divVF="<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n";
					String divRT="<td id=\"central\" colspan=\"3\">\n";	
					String divRF = "<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">";
					Pattern pat = Pattern.compile(divVF, Pattern.CASE_INSENSITIVE);
					Pattern pat2 = Pattern.compile(divRT, Pattern.CASE_INSENSITIVE);
					Pattern pat3 = Pattern.compile(divRF, Pattern.CASE_INSENSITIVE);
					Matcher m = pat.matcher(st);
					Matcher m2 = pat2.matcher(st);
					Matcher m3 = pat3.matcher(st);
					if (m.find())
					{	String s = "<div id=\"videodiv\" style=\"position:absolute;top:30%;left:1%;width:48%;height:50%;padding:5px;overflow:auto;text-align: center\">\n"+
							h+"</div>\n<div id=\"central\" style=\"position:absolute;top:30%;left:50%;width:48%;height:50%;padding:5px;overflow:auto\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}
					else if (m2.find())
					{	String s = "<td id=\"videoTd\">\n"+h+"\n</td>\n<td id=\"central\" colspan=\"2\">\n";
						String added=m.replaceFirst(s);
						tp.setText(added);
					}					
					else if (m3.find())
					{	String s = "<div id=\"videodiv\" style=\"position: absolute; top: 27%; left: 1%; width: 48%; height: 50%; overflow: auto; text-align: center; border: 1px solid gray; padding: 10px\">"+
							h+"</div><div id=\"central\" style=\"position:absolute;top:27%;left:51%;width:48%;height:50%;padding:10px;overflow:auto;text-align:center\">";
						String added=m3.replaceFirst(s);
						tp.setText(added);
					}
					else
					{	messages.setText("Impossibile aggiungere file audio. I quiz CR non ne accettano.");
						showAlert("Impossibile aggiungere file audio. I quiz CR non ne accettano.");
					}
				}        	
         	}
         });  
        Label bglabel = new Label("← per iniziare Info-Tutorial");
        bglabel.getStyleClass().add("label2");
        Label undolabel = new Label("per annullare Focus-Ctrl+Z ↓");
        Label redolabel = new Label("↓ per ripetere Focus-Ctrl+Shift+Z");
        undolabel.getStyleClass().add("label2");
        redolabel.getStyleClass().add("label2");
        media.getItems().add(textTag);
        media.getItems().add(imgTag);
        media.getItems().add(movieTag);
        media.getItems().add(audioTag);
        media.getItems().add(pdf);
        media.getItems().add(imgText);
        media.getItems().add(movieText);
        media.getItems().add(audioText);
        Menu info = new Menu("Info");
        MenuItem infoTag = new MenuItem("Tutorial");
         infoTag.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	getHostServices().showDocument("tutorial/QuestionMark.html");       	
         	}
         });  
         MenuItem licTag = new MenuItem("Licenza");
         licTag.setOnAction(new EventHandler<ActionEvent>() 
         {   @Override
             public void handle(ActionEvent event) 
         	{	getHostServices().showDocument("http://www.gnu.org/licenses/gpl-3.0.html");        	
         	}
         });  
        info.getItems().add(infoTag);
        info.getItems().add(licTag);
        menuBar.getMenus().add(file);
        menuBar.getMenus().add(modifica);
        menuBar.getMenus().add(nuovo);
        menuBar.getMenus().add(media);
        menuBar.getMenus().add(info);
        Image img1 = new Image(new FileInputStream("imgs/qm.gif"));
        ImageView view1 = new ImageView(img1);
        
        //END STATIC PART START TABPANE
        
              
        tab.setTabClosingPolicy(TabClosingPolicy.UNAVAILABLE);
        Tab qmtab = new Tab();
        Tab vftab = new Tab();
        Tab rmtab = new Tab();
        Tab cftab = new Tab();
        Tab rttab = new Tab();
        Tab crtab = new Tab();
        Tab rftab = new Tab();
        Tab maptab = new Tab();
        qmtab.setText("esempi");
        vftab.setText("vero o falso");
        rmtab.setText("risposta multipla");
        cftab.setText("completa");
        rttab.setText("riconosci");
        crtab.setText("incrocia");
        rftab.setText("riordina");
        maptab.setText("mappa");
        tab.getTabs().addAll(qmtab,vftab,rmtab,cftab,rttab,crtab,rftab,maptab);
        
        //START TABPANE QUESTIONMARK
        Text vft = new Text("- vero o falso");
        Hyperlink vfhp = new Hyperlink("esempio");
        HostServices billo=getHostServices();
        vfhp.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	billo.showDocument("https://youtu.be/-aSiW6hw5bg?si=08mptF0E3GZ5SYWY");         	
            }
        });  
        TextFlow vftf = new TextFlow(vft, vfhp);								//textflow  vf
        Text rmt = new Text("- risposta multipla"); 				
        Hyperlink rmhp = new Hyperlink("esempio");
        rmhp.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	billo.showDocument("https://youtu.be/IzWzGHcKb70?si=M9uTBn62SF26iaJI");        	
        	}
        });  
        TextFlow rmtf = new TextFlow(rmt, rmhp);								//textflow  rm
        Text cft = new Text("- completa il brano");
        Hyperlink cfhp = new Hyperlink("esempio");
        cfhp.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	billo.showDocument("https://youtu.be/HDRUu9Vu8Oc?si=3XCH1uD_sbGvjIBe");        	
        	}
        });  
        TextFlow cftf = new TextFlow(cft, cfhp);								//textflow  cf
        Text rtt = new Text("- riconosci e classifica");
        Hyperlink rthp = new Hyperlink("esempio");
        rthp.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	billo.showDocument("https://youtu.be/RR5_FxEIylY?si=TR3lMv6Exm6jP1_n");        	
        	}
        });  
        TextFlow rttf = new TextFlow(rtt, rthp);								//textflow  rt
        Text crt = new Text("- incrocia le domande con le risposte");
        Hyperlink crhp = new Hyperlink("esempio");
        crhp.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	billo.showDocument("https://youtu.be/F4NHBvpDsYE?si=ljU06eK4ghJaVj9i");        	
        	}
        });  
        TextFlow crtf = new TextFlow(crt, crhp);								//textflow  cr
        Text rft = new Text("- riordina le frasi");
        Hyperlink rfhp = new Hyperlink("esempio");
        rfhp.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	billo.showDocument("https://youtu.be/EovxQ4jnHaM?si=EVJHCcX79MAtbKNM");        	
        	}
        });  
        TextFlow rftf = new TextFlow(rft, rfhp);								//textflow rf
        AnchorPane apqm = new AnchorPane(vftf,rmtf,cftf,rttf,crtf,rftf);
        AnchorPane.setTopAnchor(vftf,50.0);
        AnchorPane.setLeftAnchor(vftf,0.0); 
        AnchorPane.setTopAnchor(rmtf,75.0);
        AnchorPane.setLeftAnchor(rmtf,0.0);  
        AnchorPane.setTopAnchor(cftf,100.0);
        AnchorPane.setLeftAnchor(cftf,0.0); 
        AnchorPane.setTopAnchor(rttf,125.0);
        AnchorPane.setLeftAnchor(rttf,0.0);  
        AnchorPane.setTopAnchor(crtf,150.0);
        AnchorPane.setLeftAnchor(crtf,0.0);
        AnchorPane.setTopAnchor(rftf,175.0);
        AnchorPane.setLeftAnchor(rftf,0.0);  
        qmtab.setContent(apqm);
        
        //START MAP TABLE
             
        ch_image = new Button("immagine");
        coords = new TextArea("");
        coords.setWrapText(true);
        EventHandler<MouseEvent> eventHandler = e -> coords.setText(coords.getText() + (int) Math.round(e.getX()-51)+","+ (int) Math.round(e.getY()-51)+",");
        AnchorPane apmap = new AnchorPane(ch_image,coords);
        AnchorPane.setTopAnchor(ch_image,50.0);
        AnchorPane.setLeftAnchor(ch_image,0.0); 
        AnchorPane.setTopAnchor(coords,50.0);
        AnchorPane.setLeftAnchor(coords,100.0);  
        ch_image.setOnAction(new EventHandler<ActionEvent>()
        {   @Override
        	public void handle(ActionEvent event) 
        	{   String folderName = nomeFile.getText().trim();
				String currentD = System.getProperty("user.dir");
				FileChooser fileChooser = new FileChooser();
	         	fileChooser.setTitle("seleziona l' immagine");
	         	File f = new File(currentD);
	         	fileChooser.setInitialDirectory(f);
	         	fileChooser.getExtensionFilters().addAll(new ExtensionFilter("file immagine", "*.jpg","*.png","*.JPG","*.jpeg","*.JPEG","*.gif"));	
	         	try
					{	File chose = fileChooser.showOpenDialog(primaryStage);
						Image img1 = new Image(new FileInputStream(chose));
			        	ImageView view2 = new ImageView(img1);
			        	apimg = new AnchorPane(view2);
			        	apimg.setTopAnchor(view2, 50.0);
			        	apimg.setLeftAnchor(view2, 50.0);
			        	scroll.setContent(apimg);
			        	//apimg.addEventFilter(MouseEvent.MOUSE_CLICKED,eventFilter);
			        	apimg.setOnMouseClicked(eventHandler);
			        	htpane.getSelectionModel().select(imgtab);						
				    }
				catch (Exception b)
					{	System.out.println(b.toString());					
					}
	         }
        });
        maptab.setContent(apmap);
        
        
        //START VF
        
        domandavf = new TextArea("");domandavf.setPromptText("domanda");
        domandavf.setWrapText(true);
        domandavf.setPrefWidth(250);
        domandavf.setPrefHeight(80);
        RadioButton vero = new RadioButton("vero");
        RadioButton falso = new RadioButton("falso");
        Button indatavf = new Button("salva quesito");
        domandevf = new Vector<StringBuffer>();
        indatavf.setOnAction(new EventHandler<ActionEvent>() 				//INDATAVF HANDLER
        {   @Override
            public void handle(ActionEvent event) 
        	{   String s0 = "";
		        String s1 = "";
		        String q = "";		        
		        String qvf = domandavf.getText().trim();		        
		        if (qvf.length() == 0)
		        {	showAlert("Non hai digitato una domanda!");
			    }
		        else if (vero.isSelected() == false && falso.isSelected() == false)
		        { 	showAlert("Non hai selezionato una risposta!");
		        }
		        else
		        {   q = domandavf.getText().replaceAll("'","&#39;").replaceAll("\"","&#34;");
		        	if (vero.isSelected() == true) 
			        {	s0 = "<p style=\"text-align:center\"><input type=\"radio\" value=\"V1\" id=\"V0\" name=\"V0\" />Vero</p><br>";
			        }		        
			        else if (vero.isSelected() == false)
			        {   s0 = "<p style=\"text-align:center\"><input type=\"radio\" value=\"V0\" id=\"V0\" name=\"V0\" />Vero</p><br>";
			        }
			        if (falso.isSelected() == true) 
			        {   s1 = "<p style=\"text-align:center\"><input type=\"radio\" value=\"V1\" id=\"V0\" name=\"V0\" />Falso</p><br>";
			        }
			        else if (falso.isSelected() == false)
			        {   s1 = "<p style=\"text-align:center\"><input type=\"radio\" value=\"V0\" id=\"V0\" name=\"V0\" />Falso</p><br>";
			        }	
			        String domvf="<br><br>" + (vectorcvf + 1) + "." + q + "<br><br>" + s0 + "<br><br>" + s1 + "<br>";
				    String dsbvf = new String(domvf);
				    domandevf.add(new StringBuffer(dsbvf));
				    vectorcvf++; 
				    messages.setText("Domande " + vectorcvf);
				    domandavf.setText("");
				}        	 
            }
        });  
        Button creavf = new Button("crea il quiz");
        creavf.setOnAction(new EventHandler<ActionEvent>() 							//CREAVF HANDLER
        {   @Override
            public void handle(ActionEvent event) 
        	{	getCheck();
        		if (check == false){}
        		else if (domandevf.size() == 0)
				{	showAlert("Non hai salvato le domande e le risposte!");
				}
				else
				{	String f2vf = "";
					if (nomeFile.getText().indexOf("VF")==-1)
					{ f2vf=nomeFile.getText()+"VF";
					}
					else
					{ f2vf=nomeFile.getText();
					}
					String HTML4 = "";
					String openHTML = "";
					String CSS = "";
					String scriptTag  = "";
					String bodyForm = "";
					String tableheader  = "";
					String w3c  = "";
					String endtable  = "";
					String end = "";
					String variabili  = "";
					String quest  = "";
					String variabili2 = "";
					String pushR  = "";
					String cutnumbers = "";
					String check  = "";
					String clock  = "";
					String correct = "";
					String error = "";
					tp.setText("");
					String currentD=System.getProperty("user.dir");
					fvf = new File(currentD+"/quiz/"+f2vf);
					fvf.mkdir();
					File fvf_bag=new File(currentD+"/quiz/"+f2vf+"/"+f2vf);
					fvf_bag.mkdir();
					if (quizMedia.isSelected())
					try
					{		FileInputStream in1 = new FileInputStream(new File("audios/applause.wav"));
					        FileOutputStream out1 = new FileOutputStream(new File(fvf_bag,"applause.wav"));
					        while (in1.available() != 0) 
					        { //finche' ci sono dati disponibili in input
					        	out1.write(in1.read()); //leggi e scrivi
							}
							in1.close();
							out1.close();
							FileInputStream in2 = new FileInputStream(new File("audios/carbrake.wav"));
							FileOutputStream out2 = new FileOutputStream(new File(fvf_bag,"carbrake.wav"));
					        while (in2.available() != 0) 
					        { //finche' ci sono dati disponibili in input
					          out2.write(in2.read()); //leggi e scrivi
					        }
					        in2.close();
					        out2.close();
					        FileInputStream in3 = new FileInputStream(new File("imgs/images1.gif"));
					        FileOutputStream out3 = new FileOutputStream(new File(fvf_bag,"images1.gif"));
					        while (in3.available() != 0) 
					        { //finche' ci sono dati disponibili in input
					          out3.write(in3.read()); //leggi e scrivi
					        }
					        in3.close();
					        out3.close();
					        FileInputStream in4 = new FileInputStream(new File("imgs/images2.gif"));
					        FileOutputStream out4 = new FileOutputStream(new File(fvf_bag,"images2.gif"));
					        while (in4.available() != 0) 
					        {	//finche' ci sono dati disponibili in input
					        	out4.write(in4.read()); //leggi e scrivi
					        }
					        in4.close();
					        out4.close();
							}
							catch (Exception e) 
							{       System.out.println(e.toString());
					        }		
						dvf = new StringBuffer[vectorcvf];
					 	domandevf.copyInto(dvf);
					 	HTML4 = "<!DOCTYPE html>";
						openHTML = "<html><head><title>"+nomeFile.getText()+"</title>\n<meta charset=\"utf-8\">\n";
						CSS = "<style  type=\"text/css\">\n<!--\n"
								+ "* {font-family:" + fontType.getValue() + ";font-size:" + fontSize.getValue() + ";color:" + fcolor +";}\n"
								+ "body {background:" + bcolor +";padding: 5px}"
								+ "img {border-radius:5px;}\n"
								+ ".button {background:" + fcolor 	+ ";color:" + bcolor + ";border-radius:5px}\n"
								+ ".button:focus {outline:none}\n"
	            				+ ".intest {position:absolute;top:1%;left:1%;width:98%;height:5%;text-align:center;overflow:auto}\n"
	            				+ ".upleft {position:absolute;top:7%;left:1%;width:47%;height:20%;text-align:center;border-width:1px;border-style:dotted;\n"
	            				+ "border-color:#717171;border-radius:5px;border-radius:5px;padding:5px;overflow:auto}\n"
	            				+ ".upright {position:absolute;top:7%;left:50%;width:47%;height:20%;border-width:1px;border-style:dotted;border-color:#717171;"
	            				+ "border-radius:5px;padding:5px;overflow:auto}\n"
	            				+ ".footer {position:absolute;top:85%;left:1%;width:98%;text-align:center}\n"
	            				+ "-->\n</style>\n";
						scriptTag = "<script src='" + f2vf + "/codice.js' type=\"text/javascript\"></script>\n";
						variabili = "var esatte = 0;\n"
					          +"var errate = 0;\n"
					          +"var risposta = '';\n"
					          +"var e = 0;\n"
					          +"var domande = new Array();\n"
					          +"var risposte = new Array();\n"
					          +"var index = 0;\n"
					          +"var i = 0;\n"
					          +"var questions = new Array();\n";
						String[] dVFform = new String[dvf.length];
				        for (int x = 0; x<dvf.length; x++)
				        {  	dVFform[x]=new String(dvf[x]);
				        }
						quest="";
						for (int a = 0; a < vectorcvf; a++) 
						{    quest=quest+"questions[" + a + "]='" + dvf[a] + "';\n";
					    }
						variabili2="var n = new Array();\n"
				         +"var ind = 0;\n"
				         +"var a = 0;\n"
				         +"var ink = new Array();\n"
				         +"ink[0]=0;\n";
						pushR = "function pushR()\n"
								        +	"{	for (var k=0; k<document.f1.elements.length; k++)\n"
								        +	"	{	if (document.f1.elements[k].checked==true)\n"
								        +	"		{	risposta=document.f1.elements[k].value;"
								        + 	"		}\n"
								        +	"		else\n "
								        + 	"		{}\n"
								        + 	"	}\n"
								        + 	"}\n";	
						cutnumbers = 
							     "function cutNumbers(n)\n" +
							     "{    var nS = n +'';\n" +
							     "     if (nS.indexOf('.')!=-1)\n" +
							     "     nS = nS.substring(0,nS.indexOf('.')+3); return nS;\n" +
							     "}\n";
						if (quizMedia.isSelected())
						{	correct = 	"	CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
										"  	'<source src=\""+f2vf+"/applause.wav\" type=\"audio/ogg\">'+\n" + 
										"  	'<source src=\""+f2vf+"/applause.wav\" type=\"audio/mpeg\">'+\n" + 
										"	'Your browser does not support the audio element.</audio>'+\n" + 
										"	'<img src=\""+ f2vf + "/images1.gif\">';\n";
							error = 	"	CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
										"	'<source src=\""+f2vf+"/carbrake.wav\" type=\"audio/ogg\">'+\n" + 
										"	'<source src=\""+f2vf+"/carbrake.wav\" type=\"audio/mpeg\">'+\n" + 
										"	'Your browser does not support the audio element.</audio>'+\n" +
										"	'<img src=\""+ f2vf + "/images2.gif\">';\n";
						}
						else
						{	correct = "";
							error = "";
						}
						check = "function check()\n"+
							          "{	pushR();\n"+
							          "		var wB=document.getElementById('central');\n"+
							          "		var CQB=document.getElementById('CQ');\n"+
							          "		var rispEsB=document.getElementById('rispEs');\n"+
							          "		var resultB=document.getElementById('result');\n"+
							          "		if(ind<questions.length && risposta=='')\n"+
							          "		{	errate++;n[errate]=ind+1;" + error + "\n" +
							          "		}\n"+
							          "		else if(ind<questions.length && risposta=='V1')\n"+
							          "		{	esatte++;a++;ink[a]=esatte;wB.innerHTML=questions[ind+1];\nind++;risposta='';"+ correct + "\n" +
							          "		}\n"+
							          "		else if(ind<questions.length && risposta=='V0')\n"+
							          "		{	errate++;n[errate]=ind+1;"+error+"\n}\n"+
							          "		else{}\n"+
							          "		var es = ink[a]-ink[a-1];\n"+
							          "		var res = (esatte - errate)/esatte;" +
							          "		var resS = cutNumbers(res);\n"+
							          "		var perc = cutNumbers((es-errate/ind)*100);\n"+
							          "		var finalV = '';\n"+
							          "		if (res<=1 && res>=0.9)\n"+
							          "		finalV= resS+' OTTIMO (tra 0.9 e 1)';\n"+
							          "		if (res<0.9 && res>=0.75)\n"+
							          "		finalV= resS+' DISTINTO (tra 0.75 e 0.9)';\n"+
							          "		else if (res<0.75 && res>=0.65)\n"+
							          "		finalV=resS+' BUONO (tra 0.65 e 0.75)';\n"+
							          "		else if (resS<0.65 && res>=0.6)\n"+
							          "		finalV=resS+' SUFFICIENTE (tra 0.6 e 0.65)';\n"+
							          "		else if (res<0.6)\n"+
							          "		finalV=resS+' NON SUFFICIENTE (minore di 0.6)';\n"+
							          "		var punteggio='Risposte esatte: '+esatte+'<br> Errate: '+errate+'<br> Percentuale: '+perc+'%<br> Valutazione: '+finalV+" +
							          "		'<br> Sono state sbagliate le domande n.:';\n"+
							          "		var err = n.join(' ');\n"+
							          "		if (esatte<questions.length) " +
							          "		{	rispEsB.innerHTML=punteggio+err+'</span>';" +
							          "		}\n" +
							          "		else if(esatte>=questions.length) {wB.innerHTML=questions[ind-1];\n"+
							          "		resultB.innerHTML='TEST COMPLETATO in '+theclock.innerHTML+'<br> ';\n"+
							          "		rispEsB.innerHTML=punteggio+err;}\n"+
							          "}\n";
					clock = 	"secs=0;\n"
								    +"mins=0;\n"
								    +"hours=0;\n"
								    +"function Clock() \n"
							        +"   {	theclock=document.getElementById('clock');\n"
							        +"   	secs++;\n"
							        +"   	if (secs>=60)\n"
							        +"   	{	secs=0;\n"
							        +"			mins++;\n"
							        +"		if (mins < 10) mins= '0' + mins;\n"
							        +"   	}\n"
							        +"   else if(mins>=60)\n"
							        +"   {	mins=0;\n"
							        +"		hours++;\n"
							        +"      if(hours <10) "
							        +"		hours='0'+hours;\n"
							        +"   }\n"
							        +"   if (secs < 10) "
							        +"		secs= '0' + secs;\n"
							        +"		theclock.innerHTML = hours + ':' + mins + ':' + secs;     \n"
							        +"   window.setTimeout('Clock();',1000);  \n"
							        +"}\n";		          
					
					bodyForm = "</head>\n<body onload='Clock()'>\n<form id='f1' name='f1' action=\"post\">\n";
					tableheader =  "<div class=\"intest\">"	+intest.getText() + "</div>\n"
					    				+"<div id=\"upleft\" class=\"upleft\">\n"
					    				+"<span id='result'>\n"+"Seleziona le risposte, poi clicca su Controlla<br><br>\n"
					    				+"<input type='button' value='Controlla' onclick='check()' class='button'></span><br><br>\n"
					    				+"<span id='clock' style='background:silver;color:red;padding:5px'>00:00:00</span></div>\n"
					    				+"<div id=\"upright\" class=\"upright\">\n"
					    				+"<span id='rispEs'>Risposte esatte: <br> Errate: <br> Percentuale: %<br>\n"
					    				+" Valutazione: <br> Sono state sbagliate le domande n.:';</span></div>\n";
					w3c = "<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n" + dvf[0] + "</div>\n";
					endtable = "<div id=\"CQ\" class=\"footer\">QuestionMark<br /></div>\n";
					end = "</form></body></html>";
					try 
					{ 	FileWriter fwCodVF = new FileWriter(fvf_bag + "/codice.js");
						BufferedWriter bwCodVF = new BufferedWriter(fwCodVF);
						PrintWriter pwCodVF = new PrintWriter(bwCodVF);
						pwCodVF.print(variabili+quest+variabili2+pushR+cutnumbers+check+clock);	
						pwCodVF.close();
					}
					catch (Exception e)
					{	System.out.println(e.toString());	
					}
					tp.setText(HTML4+openHTML+CSS+scriptTag+bodyForm+tableheader+w3c+endtable+end);
					//webengine.loadContent(tp.getText());
					if (nomeFile.getText().indexOf("VF") == -1)
					{	nomeFile.setText(nomeFile.getText()+"VF");
					}
					nomeFile.setEditable(false);
		        }
        	}
        });  								
        Button resetvf = new Button("reset");							//RESET VF
        resetvf.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	nomeFile.setText("");
        		nomeFile.selectAll();
				intest.setText("");
				domandavf.setText("");
				messages.setText("");
				tp.setText("html");
				domandevf.clear();
				vectorcvf=0;
				bcolor = "";
				fcolor = ""; 
				nomeFile.setEditable(true);
        	}
        });  
        final ToggleGroup vfgroup = new ToggleGroup();
        vero.setToggleGroup(vfgroup);
        falso.setToggleGroup(vfgroup); 
        AnchorPane apvf = new AnchorPane(domandavf,vero,falso,indatavf,creavf,resetvf);
        //positioning elements
        AnchorPane.setTopAnchor(domandavf,50.0);
        AnchorPane.setLeftAnchor(domandavf,10.0);
        AnchorPane.setTopAnchor(vero,50.0);
        AnchorPane.setLeftAnchor(vero,350.0);
        AnchorPane.setTopAnchor(falso,50.0);
        AnchorPane.setLeftAnchor(falso,450.0);
        AnchorPane.setTopAnchor(indatavf,100.0);
        AnchorPane.setLeftAnchor(indatavf,350.0);
        AnchorPane.setTopAnchor(creavf,250.0);
        AnchorPane.setLeftAnchor(creavf,10.0);
        AnchorPane.setTopAnchor(resetvf,250.0);
        AnchorPane.setLeftAnchor(resetvf,450.0);
        vftab.setContent(apvf);
        
        //START RM
        
        domandarm = new TextArea("");domandarm.setPromptText("domanda");
        domandarm.setWrapText(true);
        domandarm.setMaxWidth(300);
        domandarm.setMaxHeight(80);
        domandarm.setMinWidth(30);
        domandarm.setMinHeight(8);
        corretta = new TextArea("");corretta.setPromptText("corretta");
        corretta.setWrapText(true);
        corretta.setMaxWidth(280);
        corretta.setMaxHeight(40);
        corretta.setMinWidth(30);
        corretta.setMinHeight(8);
        errata1 = new TextArea("");errata1.setPromptText("errata1");
        errata1.setWrapText(true);
        errata1.setMaxWidth(280);
        errata1.setMaxHeight(40);
        errata1.setMinWidth(30);
        errata1.setMinHeight(8);
        errata2 = new TextArea("");errata2.setPromptText("errata2");
        errata2.setWrapText(true);
        errata2.setMaxWidth(280);
        errata2.setMaxHeight(40);
        errata2.setMinWidth(30);
        errata2.setMinHeight(8);
        errata3 = new TextArea("");errata3.setPromptText("errata3");
        errata3.setWrapText(true);
        errata3.setMaxWidth(280);
        errata3.setMaxHeight(40);
        errata3.setMinWidth(30);
        errata3.setMinHeight(8);
        Button indatarm = new Button("salva quesito");
        domanderm = new Vector<StringBuffer>();
        indatarm.setOnAction(new EventHandler<ActionEvent>() 							//INDATARM
        {   @Override
            public void handle(ActionEvent event) 
        	{	if (domandarm.getText().length() == 0)
				{	showAlert("Non hai digitato una domanda!");
				}
        		else if (corretta.getText().length() == 0)
				{	showAlert("Non hai digitato la risposta esatta!");
				}
        		else if (errata1.getText().length() == 0)
				{	showAlert("Non hai digitato la prima risposta errata!");
				}
        		else if (errata2.getText().length() == 0)
				{	showAlert("Non hai digitato la seconda risposta errata!");
				}
        		else if (errata3.getText().length() == 0)
				{	showAlert("Non hai digitato la terza risposta errata!");
				}
        		else
				{	StringBuffer esRMsb = new StringBuffer(corretta.getText().trim().replaceAll("'","&#39;").replaceAll("\"","&#34;"));
			        StringBuffer er1RMsb = new StringBuffer(errata1.getText().trim().replaceAll("'","&#39;").replaceAll("\"","&#34;"));
			        StringBuffer er2RMsb = new StringBuffer(errata2.getText().trim().replaceAll("'","&#39;").replaceAll("\"","&#34;"));
			        StringBuffer er3RMsb = new StringBuffer(errata3.getText().trim().replaceAll("'","&#39;").replaceAll("\"","&#34;"));
			        StringBuffer rmTasb = new StringBuffer(domandarm.getText().trim().replaceAll("'","&#39;").replaceAll("\"","&#34;"));
			        String[] quest = new String[4];
			        quest[0] = "<input type=\"radio\" value=\"" + esRMsb.substring(0, 1) +
			            "1\" name=\"r" + vectorcrm + "\">" + " " + esRMsb + "<br>";
			        quest[1] = "<input type=\"radio\" value=\"" + er1RMsb.substring(0, 1) +
			            "\" name=\"r" + vectorcrm + "\">"  + " " +  er1RMsb + "<br>";
			        quest[2] = "<input type=\"radio\" value=\"" + er2RMsb.substring(0, 1) +
			            "\" name=\"r" + vectorcrm + "\">"  + " " +  er2RMsb + "<br>";
			        quest[3] = "<input type=\"radio\" value=\"" + er3RMsb.substring(0, 1) +
			            "\" name=\"r" + vectorcrm + "\">"  + " " +  er3RMsb + "<br>";
			        List<String> strList = Arrays.asList(quest);
			        Collections.shuffle(strList);
			        quest = strList.toArray(new String[strList.size()]);
			        String domRM = (vectorcrm + 1) + ".<span style=\"font-weight:bold\">" + rmTasb
		              + "</span><br><br>" + quest[0] + quest[1] + quest[2] + quest[3];
			        StringBuffer dsbRM = new StringBuffer(domRM);
			        domanderm.add(dsbRM);
			        vectorcrm++;
			        domandarm.setText("");
			        corretta.setText("");
			        errata1.setText("");
			        errata2.setText("");
			        errata3.setText("");
			        messages.setText("Domande " + vectorcrm); 
				}
        	}
        }); 
        Button crearm = new Button("crea il quiz");
        crearm.setOnAction(new EventHandler<ActionEvent>() 								//CREA RM
        {   @Override
            public void handle(ActionEvent event) 
        	{	getCheck();
	        	if (check == false){}
	        	else if (domanderm.size() == 0)
				{	showAlert("Non hai salvato le domande e le risposte!");
				}
				else
				{	String HTML4 = "";
					String openHTML = "";
					String CSS = "";
					String scriptTag = "";
					String bodyForm = "";
					String tableheader = "";
					String w3c = "";
					String endtable = "";
					String end = "";
					String script2 = "";
					String quest = "";
					String variabili2 = "";
					String check = "";
					String clock = "";
					String correct = "";
					String error = "";
					drm = new StringBuffer[vectorcrm];
		        	domanderm.copyInto(drm);
		        	String f2rm = "";
		        	if (nomeFile.getText().indexOf("RM")==-1)
					{ f2rm=nomeFile.getText()+"RM";
					}
					else
					{ f2rm=nomeFile.getText();
					}		        	
		        	String currentD=System.getProperty("user.dir");
					frm = new File(currentD+"/quiz/"+f2rm);
					frm.mkdir();
					File frm_bag=new File(currentD+"/quiz/"+f2rm+"/"+f2rm);
					frm_bag.mkdir();		        	
		        	tp.setText("");
		        	if (quizMedia.isSelected())
					try
		        	{	FileInputStream in1 = new FileInputStream(new File("audios/applause.wav"));
				        FileOutputStream out1 = new FileOutputStream(new File(frm_bag,"applause.wav"));
				        while (in1.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out1.write(in1.read()); //leggi e scrivi
				        }
				        in1.close();
				        out1.close();
				        FileInputStream in2 = new FileInputStream(new File("audios/carbrake.wav"));
				        FileOutputStream out2 = new FileOutputStream(new File(frm_bag,"carbrake.wav"));
				        while (in2.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out2.write(in2.read()); //leggi e scrivi
				        }
				        in2.close();
				        out2.close();
				        FileInputStream in3 = new FileInputStream(new File("imgs/images1.gif"));
				        FileOutputStream out3 = new FileOutputStream(new File(frm_bag,"images1.gif"));
				        while (in3.available() != 0) 
				        { //finche' ci sono dati disponibili in input
				          out3.write(in3.read()); //leggi e scrivi
				        }
				        in3.close();
				        out3.close();
				        FileInputStream in4 = new FileInputStream(new File("imgs/images2.gif"));
				        FileOutputStream out4 = new FileOutputStream(new File(frm_bag,"images2.gif"));
				        while (in4.available() != 0) 
				        {	//finche' ci sono dati disponibili in input
				        	out4.write(in4.read()); //leggi e scrivi
				        }
				        in4.close();
				        out4.close();
					}
					catch (Exception e) 
					{       System.out.println(e.toString());
			        }		
					drm = new StringBuffer[vectorcrm];
				 	domanderm.copyInto(drm);
				 	HTML4 = "<!DOCTYPE html>\n";
					openHTML = "<html>\n<head>\n<title>"+nomeFile.getText()+"</title>\n<meta charset=\"utf-8\">\n";
					CSS = "<style  type=\"text/css\">\n<!--\n"
					+ "* {font-family:" + fontType.getValue() + ";font-size: " + fontSize.getValue() + ";color:" + fcolor + "}\n"
					+ "body {background:" + bcolor + ";padding:5px;}\n"
					+ "img{border-radius:5px;}"
    				+ ".button{background:" + fcolor + ";color:" + bcolor + ";border-radius:5px}\n"
    				+ "textarea:focus, input:focus, button:focus {outline:none}\n"
    				+ ".intest {position:absolute;top:1%;left:1%;width:98%;height:5%;text-align:center}\n"
    				+ ".upleft {position:absolute;top:7%;left:1%;width:47%;height:20%;text-align:center;\n"  
    				+ "border-width:1px;border-style:dotted;border-color:#717171;border-radius:5px;padding:5px;overflow:auto}\n"
    				+ ".upright{position:absolute;top:7%;left:50%;width:47%;height:20%;\n" 
    				+ "border-width:1px;border-style:dotted;border-radius:5px;border-color:#717171;padding:5px;overflow:auto}\n"
    				+ "--></style>\n";
					scriptTag = "<script src='" + f2rm + "/codice.js' type=\"text/javascript\"></script>\n";
					script2 =  "var esatte = 0;\n"
		        			+"var errate = 0;\n"
		        			+"var risposta = '';\n"
		        			+"var e = 0;\n"
		        			+"var domande = new Array();\n"
		        			+"var risposte = new Array();\n"
		        			+"var index = 0;\n"
		        			+"var i = 0;\n"
		        			+"var questions = new Array();\n"
		        			+"function pushR()\n"
		        			+"{	for (var k=0; k<document.f1.elements.length; k++)\n"
		        			+"	{	if (document.f1.elements[k].checked==true)\n"
		        			+"		{	risposta=document.f1.elements[k].value;"
		        			+ "		\n}\n"
		        			+ "	}\n"
		        			+ "}\n";
		        	for (int a = 0; a < vectorcrm; a++) 
					{    quest=quest+"\n"+"questions[" + a + "]='" + new String(drm[a]) + "';\n";
				    }
					variabili2 = "var n = new Array();var ind=0;\n";
					if (quizMedia.isSelected())
					{	correct = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
							"  '<source src=\""+f2rm+"/applause.wav\" type=\"audio/ogg\">'+\n" + 
							"  '<source src=\""+f2rm+"/applause.wav\" type=\"audio/mpeg\">'+\n" + 
							"'Your browser does not support the audio element.</audio>'+\n" + 
							"'<img src=\""+ f2rm + "/images1.gif\">';\n";
						error = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
								"'<source src=\""+f2rm+"/carbrake.wav\" type=\"audio/ogg\">'+\n" + 
								"'<source src=\""+f2rm+"/carbrake.wav\" type=\"audio/mpeg\">'+\n" + 
								"'Your browser does not support the audio element.</audio>'+\n" +
								"'<img src=\""+ f2rm + "/images2.gif\">';\n";
					}
					else
					{	correct = "";
						error = "";
					}
				  check ="	function check()\n"
			          +"		{	pushR();\n"
			          +"			var wB=document.getElementById('central');\n"
			          +"			var CQB=document.getElementById('CQ');\n"
			          +"			var rispEsB=document.getElementById('rispEs');\n"
			          +"			var resultB=document.getElementById('result');\n"
			          +"			if(ind<questions.length && risposta=='')\n"
			          +"			{	errate++;\n"
			          +"				n[errate]=ind+1;\n" +error
			          +"			\n}\n"
			          +"			else if(ind<questions.length && risposta.length==2)\n"
			          +"			{	esatte++;\n"
			          +"				wB.innerHTML=questions[ind+1];\n"
			          +"				ind++;\n" + correct
			          +"			\n}\n"
			          +"			else if(ind<questions.length && risposta.length!=2)\n"
			          +"			{	errate++;\n"
			          +"				n[errate]=ind+1;"+error
			          +"				\n}\n"
			          +"			else{}\n"
			          +"			var res = ((esatte-errate)/esatte);\n"
			          +"			var resS = res +'';\n"
			          +"			if (resS.indexOf('.')!=-1)\n"
			          +"			resS = resS.substring(0,resS.indexOf('.')+3);\n"
			          +"			var perc = esatte/(esatte+errate)*100+'';\n"
			          +"			if (perc.indexOf('.')!=-1)\n"
			          +"			{	perc = perc.substring(0,perc.indexOf('.')+3);"
			          +"			\n}\n"
					  +"			var finalV = '';\n"
					  +"			if (res<=1 && res>=0.9)\n"
					  +"			finalV= resS+' OTTIMO (tra 0.9 e 1)';\n"
					  +"			if (res<0.9 && res>=0.75)\n"
					  +"			finalV= resS+' DISTINTO (tra 0.75 e 0.9)';\n"
					  +"			else if (res<0.75 && res>=0.65)\n"
					  +"			finalV=resS+' BUONO (tra 0.65 e 0.75)';\n"
					  +"			else if (res<0.65 && res>=0.6)\n"
					  +"			finalV=resS+' SUFFICIENTE (tra 0.6 e 0.65)';\n"
					  +"			else if (res<0.6)\n"
					  +"			finalV=resS+' NON SUFFICIENTE (minore di 0.6)';\n"
			          +"			var punteggio='Risposte esatte: '+esatte+'<br> Errate: '+errate+\n"
			          +"			'<BR> Percentuale: '+perc+'%<br>'+ \n" 
			          +"			'Valutazione: '+finalV+'<BR> Sono state sbagliate le domande n.:';\n"
			          +"			var err = n.join(' ');\n"
			          +"			if (esatte<questions.length) "
			          +"			{	rispEsB.innerHTML=punteggio+err;"
			          +"			\n}\n"
			          +"			else if(esatte>=questions.length) "
			          +"			{	wB.innerHTML=questions[ind-1];" +"\n"
			          +"				resultB.innerHTML='<span style = \"font-weight:bold\" >TEST COMPLETATO in '+theclock.innerHTML+'<\\/span>';" 
			          +"				rispEsB.innerHTML=punteggio+err;"
			          +"			\n}"
			          + "\n}\n"; 
			          clock =  "secs=0;\n"
		        		       +"mins=0;\n"
		        		       +"hours=0;\n"
		        		       +"function Clock() \n"
		        		       +"   {theclock=document.getElementById('clock');\n"
		        		       +"   secs++;\n"
		        		       +"   if (secs>=60)\n"
		        		       +"   {	secs=0;\n"
		        		       +"	mins++;\n"
		        		       +"	if (mins < 10) mins= '0' + mins;\n"
		        		       +"   }\n"
		        		       +"   else if(mins>=60)\n"
		        		       +"   {	mins=0;\n"
		        		       +"	hours++;\n"
		        		       +"        if(hours <10) hours='0'+hours;\n"
		        		       +"   }\n"
		        		       +"   if (secs < 10) secs= '0' + secs;\n"
		        		       +"theclock.innerHTML = hours + ':' + mins + ':' + secs;     \n"
		        		       +"   window.setTimeout('Clock();',1000);  \n"
		        		       +"}\n";
				      bodyForm = "</head>\n<body onload='Clock()'>\n<form id='f1' name='f1' action=\"post\">\n";
				      tableheader = "<div id=\"intest\" class=\"intest\">"+ intest.getText() + "</div>\n"
		            				+"<div id=\"upleft\" class=\"upleft\">\n"
		            				+"<span id='result'>\n"+"Seleziona le risposte, poi clicca su Controlla<br><br>\n"
		            				+"<input type='button' value='Controlla' onclick='check()' class='button'></span><br><br>\n"
		            				+"<span id='clock' style='background:silver;color:red;padding:5px'>00:00:00</span></div>\n"
		            				+"<div id=\"upright\" class=\"upright\">\n"
		            				+"<span id='rispEs'>Risposte esatte: <br> Errate: <br> Percentuale: %<br>\n"
		            				+" Valutazione: <br> Sono state sbagliate le domande n.:';</span></div>\n";
				      w3c = "<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n" 
				            				+ drm[0] + "\n</div>\n";
				      endtable = "<div id=\"CQ\" style=\"position:absolute;top:85%;left:1%;width:98%;text-align:center\">\n"
				        					+"QuestionMark</div>\n";
				      end = "</form></body></html>";
			        try 
			        { 	FileWriter fwCodRM = new FileWriter(frm_bag + "/codice.js");
			        	BufferedWriter bwCodRM = new BufferedWriter(fwCodRM);
			        	PrintWriter pwCodRM = new PrintWriter(bwCodRM);
			        	pwCodRM.print(script2+quest+variabili2+check+clock);	
			        	pwCodRM.close();
			        }
			        catch (Exception e)
			        {	System.out.println(e.toString());	
			        }
			        tp.setText(HTML4+openHTML+CSS+scriptTag+bodyForm+tableheader+w3c+endtable+end);
			        if (nomeFile.getText().indexOf("RM") == -1)
					{	nomeFile.setText(nomeFile.getText()+"RM");
					}
					nomeFile.setEditable(false);
				}	             	
        	}
        }); 
        Button resetrm = new Button("reset");								//RESET RM
        resetrm.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	nomeFile.setText("");
				intest.setText("");
				domandarm.setText("");
				corretta.setText("");
				errata1.setText("");
				errata2.setText("");
				errata3.setText("");
				messages.setText("");
				tp.setText("html");
				domanderm.clear();
				vectorcrm=0;
				bcolor = "";
				fcolor = ""; 
				nomeFile.setEditable(true);
        	}
        }); 
        AnchorPane aprm = new AnchorPane(domandarm,corretta,errata1,errata2,errata3,indatarm,crearm,resetrm);
        //positioning elements
        AnchorPane.setTopAnchor(domandarm,50.0);
        AnchorPane.setLeftAnchor(domandarm,10.0);
        AnchorPane.setTopAnchor(corretta,50.0);
        AnchorPane.setLeftAnchor(corretta,350.0);
        AnchorPane.setTopAnchor(errata1,100.0);
        AnchorPane.setLeftAnchor(errata1,350.0);
        AnchorPane.setTopAnchor(errata2,150.0);
        AnchorPane.setLeftAnchor(errata2,350.0);
        AnchorPane.setTopAnchor(errata3,200.0);
        AnchorPane.setLeftAnchor(errata3,350.0);        
        AnchorPane.setTopAnchor(indatarm,150.0);
        AnchorPane.setLeftAnchor(indatarm,10.0);
        AnchorPane.setTopAnchor(crearm,260.0);
        AnchorPane.setLeftAnchor(crearm,10.0);
        AnchorPane.setTopAnchor(resetrm,260.0);
        AnchorPane.setLeftAnchor(resetrm,350.0);
        rmtab.setContent(aprm);
        
        //START CF
        
        cfta = new TextArea("");cfta.setPromptText("incolla qui il testo");
        String txtttip = "incollare il testo e selezionare una per una le parole mancanti"; 
        Tooltip cftatip = new Tooltip(txtttip);
        cfta.setTooltip(cftatip);
        cfta.setWrapText(true);
        cfta.setMaxWidth(650);
        cfta.setMaxHeight(200);
        cfta.setMinWidth(65);
        cfta.setMinHeight(20);
        CheckBox wordsyes = new CheckBox("mancanti visibili?");
        Button indatacf = new Button("salva quesito");
        domandecf = new Vector<StringBuffer>();
        indatacf.setOnAction(new EventHandler<ActionEvent>() 						//INDATA CF
        {   @Override
            public void handle(ActionEvent event) 
        	{	if (cfta.getText().length() == 0)
				{	showAlert("Non hai incollato il testo!");
				}
				else if (cfta.getSelectedText() == null || cfta.getSelectedText().length() == 0)
				{	showAlert("Non hai selezionato testo!");				
				}
				else
				{   domandecf.add(new StringBuffer(cfta.getSelectedText().trim().replaceAll("'", "&#39;").replaceAll("\"", "&#34;")));
			        cfta.replaceSelection("<span id='s" + vectorccf + "'>" + (vectorccf + 1) + "<input type='text' size='" + (domandecf.lastElement().length() + 1) + "'></span>");
			        vectorccf++;
			        messages.setText("Item inseriti: " + vectorccf);
			        cfta.requestFocus();
				}       	
        	}
        });  
        Button creacf = new Button("crea il quiz");								//CREACF
        creacf.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	getCheck();
        		if (check == false){}
        		else if (domandecf.size() == 0)
				{	showAlert("Non hai salvato le domande!");
				}
				else				
				{	String s2CF = "";
					if (nomeFile.getText().indexOf("CF")==-1)
					{ s2CF=nomeFile.getText()+"CF";
					}
					else
					{ s2CF=nomeFile.getText();
					}
					String content = cfta.getText();
					tp.setText("");
					dcf = new StringBuffer[vectorccf];
			        domandecf.copyInto(dcf);
			        String doctype = "";
			        String htmlOpen = "";
			        String style = "";
			        String scriptLink = "";
			        String bodyForm = "";
			        String intestazione = "";
			        String upLeft = "";
			        String upRight = "";
			        String beta = "";
			        String w3c = "";
			        String endtable = "";
			        String end = "";		        
			        String correct = "";
					String error = "" ;
					String variabili1 = "";
					String variabili2 = "";
					String pushr = "";
					String check = "";
					String clock = "";					
					String currentD=System.getProperty("user.dir");
					fcf = new File(currentD+"/quiz/"+s2CF);
					fcf.mkdir();
					File fcf_bag=new File(currentD+"/quiz/"+s2CF+"/"+s2CF);
					fcf_bag.mkdir();						
					if (quizMedia.isSelected())
				{	correct = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
						"  '<source src=\""+ s2CF +"/applause.wav\" type=\"audio/ogg\">'+\n" + 
						"  '<source src=\""+ s2CF +"/applause.wav\" type=\"audio/mpeg\">'+\n" + 
						"'Your browser does not support the audio element.</audio>'+\n" + 
						"'<img src=\""+ s2CF + "/images1.gif\">';\n";
					error = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
							"'<source src=\""+ s2CF +"/carbrake.wav\" type=\"audio/ogg\">'+\n" + 
							"'<source src=\""+ s2CF +"/carbrake.wav\" type=\"audio/mpeg\">'+\n" + 
							"'Your browser does not support the audio element.</audio>'+\n" +
							"'<img src=\""+ s2CF + "/images2.gif\">';\n";
					try
					{		FileInputStream in1 = new FileInputStream(new File("audios/applause.wav"));
					        FileOutputStream out1 = new FileOutputStream(new File(fcf_bag,"applause.wav"));
					        while (in1.available() != 0) 
					        { //finche' ci sono dati disponibili in input
					          out1.write(in1.read()); //leggi e scrivi
					        }
					        in1.close();
					        out1.close();
					        FileInputStream in2 = new FileInputStream(new File("audios/carbrake.wav"));
					        FileOutputStream out2 = new FileOutputStream(new File(fcf_bag,"carbrake.wav"));
					        while (in2.available() != 0) 
					        { //finche' ci sono dati disponibili in input
					          out2.write(in2.read()); //leggi e scrivi
					        }
					        in2.close();
					        out2.close();
					        FileInputStream in3 = new FileInputStream(new File("imgs/images1.gif"));
					        FileOutputStream out3 = new FileOutputStream(new File(fcf_bag,"images1.gif"));
					        while (in3.available() != 0) 
					        { //finche' ci sono dati disponibili in input
					          out3.write(in3.read()); //leggi e scrivi
					        }
					        in3.close();
					        out3.close();
					        FileInputStream in4 = new FileInputStream(new File("imgs/images2.gif"));
					        FileOutputStream out4 = new FileOutputStream(new File(fcf_bag,"images2.gif"));
					        while (in4.available() != 0) 
					        {	//finche' ci sono dati disponibili in input
					        	out4.write(in4.read()); //leggi e scrivi
					        }
					        in4.close();
					        out4.close();
					}
					catch (Exception e) 
					{       System.out.println(e.toString());
			        }		
				}
				else
				{	correct = "";
					error = "";
				}		        
		        doctype = "<!DOCTYPE html>\n";
		        htmlOpen = "<html><head>\n<title>" + s2CF + "</title>\n<style type=\"text/css\">\n<!--\n";
		        style = "* {font-family:" + fontType.getValue() + ";font-size: " + fontSize.getValue() + ";color:" + fcolor + "}\n"
				+ "body {background:" + bcolor + ";padding:5px;}\n"
				+ "img {border-radius:5px;}\n"
				+ "input,div {font-size:"+fontSize.getValue()+";border-radius:10px;padding:5px}\n"
				+ "input:focus {outline:none}\n"
				+ ".button{background:" + fcolor + ";color:" + bcolor + ";}\n"            	
            	+ ".intest {position:absolute;top:1%;left:1%;width:98%;height:5%;text-align:center}\n"
            	+ ".upleft {position:absolute;top:7%;left:1%;width:47%;height:20%;text-align:center;border-width:1px;border-style:dotted;"
            	+ "border-color:#717171;border-radius:5px;padding:5px;overflow:auto}\n"
            	+ ".upright {position:absolute;top:7%;left:50%;width:47%;height:20%;border-width:1px;border-style:dotted;"
            	+ "border-color:#717171;border-radius:5px;padding:5px;overflow:auto}\n-->\n</style>\n";
		        scriptLink = "<script src='" + s2CF + "/codice.js' type=\"text/javascript\"></script></head>";
				bodyForm = "<body onload='Clock()'>\n<form id='f' name='f' action='post'>\n";
				intestazione = "<div id=\"intest\" class=\"intest\">"+ intest.getText() + "</div>\n";
				upLeft = "<div id=\"upleft\" class=\"upleft\">\n"
	    				+"<span id='result'>Digita o trascina le parole mancanti nelle caselle di testo appropriate," +"\n"
						+" quando hai finito clicca su Controlla<br><br>\n"
	    				+"<input type='button' value='Controlla' onclick='check()' class='button'></span><br><br>\n"
	    				+"<span id='clock' style='background:silver;color:red;padding:5px'>00:00:00</span></div></form>\n";
				upRight = "<div id=\"upright\" class=\"upright\">\n"
	    				+"<span id='rispEs'>Risposte esatte: <br> Errate: <br> Percentuale: %<br>\n"
	    				+" Valutazione: <br> Sono state sbagliate le domande n.:';</span></div>\n";
				
				String[] dcf2 = new String[dcf.length];
				for (int g = 0; g < dcf.length; g++)
				{	dcf2[g]=new String(dcf[g]);				
				}
				Arrays.sort(dcf2);
				for(int y=0; y<dcf.length; y++)
				{	beta = beta + " - " + dcf2[y];
				}
				if (wordsyes.isSelected())
					upRight = upRight.replace("</div>","<br> Parole mancanti: "+beta+"</div>");			
				w3c = "<form id='f1' name='f1' action='post'>" 
	    				+"<div id=\"central\" style=\"position:absolute;top:30%;left:1%;width:98%;height:50%;padding:5px;overflow:auto\">\n" 
	    				+ content + "</div>\n";
				endtable = "<div id=\"CQ\" style=\"position:absolute;top:85%;left:1%;width:98%;text-align:center\">\n"
						+"QuestionMark</div>\n";
				end = "</form></body></html>";
				tp.setText(doctype+htmlOpen+style+scriptLink+bodyForm+intestazione+upLeft+upRight+w3c+endtable+end);
				//webengine.loadContent(tp.getText());
		        try
		        { FileWriter fwCodCF = new FileWriter(fcf_bag + "/codice.js");
		          BufferedWriter bwCodCF = new BufferedWriter(fwCodCF);
		          PrintWriter pwCodCF = new PrintWriter(bwCodCF);
		          variabili1 = "var mancanti = new Array();\n";
		          String mancanti = "";
		          for (int a = 0; a < dcf.length; a++) 
		          { mancanti = mancanti + "mancanti[" + a + "] = '" + dcf[a] + "';\n";
		          }
		          variabili1 = variabili1 + mancanti;
		          String msort = "var mSort = new Array();\n";
		          for (int a = 0; a < dcf.length; a++) 
		          { msort = msort + "mSort[" + a + "] = '" + dcf[a] + "';\n";
		          }
		          variabili1 = variabili1 + msort;
		          pushr = 
		          "var risposte = new Array();\n" +
		          "function pushR()\n" +
		          "{	for (var e = 0; e < " + dcf.length + "; e++)\n" +
		          "		{	var risp1=document.f1.elements[e].value; \n" +
		          "			if (risp1.charAt(0)==' '&&risp1.charAt(risp1.length-1)==' ')\n" +
		          "			{	risp2=risp1.replace(risp1.charAt(risp1.length-1),'');" +
		          "				risp3=risp2.replace(risp1.charAt(0),'');risposte[e]=risp3;\n" +
		          "			}\n" +
		          "			else if (risp1.charAt(0)==' ')\n   " +
		          "			{	risp2=risp1.replace(risp1.charAt(0),'');\n" +
		          "				risposte[e]=risp2;\n " +
		          "			}  " +
		          "			else if(risp1.charAt(risp1.length-1)==' ')\n" +
		          "			{	risp2=risp1.replace(risp1.charAt(risp1.length-1),'');\n" +
		          "				risposte[e]=risp2;\n" +
		          "			}\n " +
		          "			else\n " +
		          "			{	risposte[e]=risp1.replace(/'/gi, \"&#39\").replace(/\"/gi, \"&#34\");\n" +
		          "			}\n" +	
		          "		} \n" +
		          "}\n";
		          variabili2 = 
		          "var n = new Array();\n" +
		          "var a = 0;\n" +
		          "var esatte = 0;\n" +
		          "var errate = 0;\n" +
		          "var ink = new Array();\nink[0]=0;\n";
		          check = 
		          "function check()\n" +
		          "{	pushR();\n" +
		          " 	var CQB = document.getElementById('CQ');" +
		          "		for(var ind = 0; ind < mancanti.length; ind++)\n" +
		          "		{	if (risposte[ind] == '')\n" +
		          "			{	errate++;n[errate]=ind+1;\n"  + error +
		          "			\n}\n" +
		          "			else if(mancanti[ind]==risposte[ind])\n" +
		          "			{	esatte++;indB=document.getElementById('s'+ind);\n" +
		          "				indB.innerHTML='<input type=\"hidden\" value=\"'+mancanti[ind]+'\"><span> <b>'+(ind+1)+'.'+mancanti[ind]+'<\\/b><\\/span>';\n" + correct +
		          "			\n}\n" +
		          "			else\n" +
		          "			{	errate++;\n" +
		          "				n[errate]=ind+1;\n" +
		          				error +
		          "			\n}\n" +
		          "		}\n" +
		          "		a++;\nink[a]=esatte;var est=ink[a]-ink[a-1];\n" +
		          "		var res = ((est-errate)/" + dcf.length + ");\n" +
		          "		var resS = res +'';\n" +
		          "		if (resS.indexOf('.')!=-1)\n" +
		          "		resS = resS.substring(0,resS.indexOf('.')+3);\n" +
		          "		var perc = est/(est+errate)*100+'';\n" +
		          "		if (perc.indexOf('.')!=-1)\n" +
		          "		{	perc = perc.substring(0,perc.indexOf('.')+3);\n" +
		          "		}" +
		          "		if (est>=" + dcf.length + ")\n" +
		          "		{	var finalV = '';\n"+
				  "			if (res<=1 && res>=0.9)\n"+
				  "			finalV= resS+' OTTIMO (tra 0.9 e 1)';\n"+
				  "			if (res<0.9 && res>=0.75)\n"+
				  "			finalV= resS+' DISTINTO (tra 0.75 e 0.9)';\n"+
				  "			else if (res<0.75 && res>=0.65)\n"+
				  "			finalV=resS+' BUONO (tra 0.65 e 0.75)';\n"+
				  "			else if (res<0.65 && res>=0.6)\n"+
				  "			finalV=resS+' SUFFICIENTE (tra 0.6 e 0.65)';\n"+
				  "			else if (res<0.6)\n"+
				  "			finalV=resS+' NON SUFFICIENTE (minore di 0.6)';\n"+          
		          "			var punteggio='<span>Esatte: '+est+'<br> Errate: '+errate+'<br>Perc.: '+perc+'%<br>Valutazione: '+finalV+'<br>Sbagliate le domande n.: ';\n" +
		          "			var err = n.join(' ');var rispEsB=document.getElementById('rispEs');\n" +
		          "			rispEsB.innerHTML=punteggio+err+'<\\/span>';var resultB=document.getElementById('result');\n" +
		          "			resultB.innerHTML='<span style = \"font-weight: bold\">TEST COMPLETATO IN '+theclock.innerHTML+'</span>';\n" +
		          "		}\n" +
		          "		else\n " +
		          "		{	alert('Risposte esatte: '+est+' errate: '+errate+' Percentuale: '+perc+'%');\n" +
		          "		}\n" +
		          "}\n";
		          clock =
		          "secs=0;\n" +
		          "mins=0;\n" +
		          "hours=0;\n" +
		          "function Clock()\n " +
		          "{	theclock=document.getElementById('clock');\n" +
		          "   	secs++;\n" +
		          "   	if (secs>=60)\n" +
		          "   	{	secs=0;\n" +
		          "			mins++;\n" +
		          "			if (mins < 10)\n" +
		          "			mins= '0' + mins;\n" +
		          "		}\n" +
		          "	   else if(mins>=60)\n" +
		          "    {	mins=0;\n" +
		          "			hours++;\n" +
		          "		    if(hours <10) hours='0'+hours;\n" +
		          "    }\n" +
		          "   if (secs < 10)\n" + 
		          "	  secs= '0' + secs;\n" +
		          "   theclock.innerHTML = hours + ':' + mins + ':' + secs;\n" +
		          "   window.setTimeout('Clock();',1000);\n  " +
		          "}";
		          pwCodCF.print(variabili1+pushr+variabili2+check+clock);
		          if (nomeFile.getText().indexOf("CF") == -1)
					{	nomeFile.setText(nomeFile.getText()+"CF");
					}
		          nomeFile.setEditable(false);
		          pwCodCF.close();
		          bwCodCF.close();
		          fwCodCF.close();          
		        }
		        catch(Exception e) 
		        { System.out.println(e.toString());
		        }
			  }        	
        	}
        });  
        Button resetcf = new Button("reset");							//RESET CF
        resetcf.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	nomeFile.setText("");
				intest.setText("");
				messages.setText("");
				tp.setText("html");
				cfta.setText("");
				domandecf.clear();
				vectorccf=0;
				bcolor = "";
				fcolor = ""; 
				nomeFile.setEditable(true);
        	}
        });  
        AnchorPane apcf = new AnchorPane(cfta,wordsyes,indatacf,creacf,resetcf);
        AnchorPane.setTopAnchor(cfta,20.0);
        AnchorPane.setLeftAnchor(cfta,10.0);
        AnchorPane.setTopAnchor(wordsyes,240.0);
        AnchorPane.setLeftAnchor(wordsyes,10.0);
        AnchorPane.setTopAnchor(indatacf,240.0);
        AnchorPane.setLeftAnchor(indatacf,300.0);
        AnchorPane.setTopAnchor(creacf,300.0);
        AnchorPane.setLeftAnchor(creacf,10.0);
        AnchorPane.setTopAnchor(resetcf,300.0);
        AnchorPane.setLeftAnchor(resetcf,300.0);
        cftab.setContent(apcf);
        
        //START RT
        
        TextArea category = new TextArea("");category.setPromptText("definisci categorie");
        String cttip = "scrivere le categorie separate da un trattino '-'; es. maschile-femminile-neutro";
        Tooltip cattip = new Tooltip(cttip);
        category.setTooltip(cattip);
        category.setWrapText(true);
        category.setMaxWidth(250);
        category.setMaxHeight(50);
        category.setMinWidth(3);
        category.setMinHeight(5);
        TextArea catnumbers = new TextArea("");catnumbers.setPromptText("numeri categorie");
        String cnttip = "scrivere i numeri delle categorie separati da un trattino '-'; es. 2-4-1";
        Tooltip catntip = new Tooltip(cnttip);
        catnumbers.setTooltip(catntip);
        catnumbers.setWrapText(true);
        catnumbers.setMaxWidth(250);
        catnumbers.setMaxHeight(50);
        catnumbers.setMinWidth(3);
        catnumbers.setMinHeight(5);
        rtta = new TextArea("");rtta.setPromptText("incolla qui il testo");
        Tooltip rttatip = new Tooltip(txtttip);
        cfta.setTooltip(rttatip);
        rtta.setTooltip(rttatip);
        rtta.setWrapText(true);
        rtta.setMaxWidth(600);
        rtta.setMaxHeight(150);
        rtta.setMinWidth(6);
        rtta.setMinHeight(2);
        StringBuffer catIns[][] = new StringBuffer[10][10];
        domandert = new Vector<StringBuffer>();
        Button incategory = new Button("salva categoria");
        incategory.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	final Tooltip g = new Tooltip();
        		if (category.getText() == null || category.getText() == "")
				{	showAlert("Non hai digitato categorie!");			
				}
				else if (category.getText().indexOf('-') == -1)
				{	showAlert("Le categorie devono essere separate da un trattino '-'!");			
				}
				else
				{	if (catCount == 0)
			        {	messages.setText("Categorie inserite: " + category.getText());
						g.setText("Categorie inserite:\n " + category.getText());
					}
					else
					{	messages.setText(messages.getText()+"; "+ category.getText());
						g.setText(messages.getText());
					}			        	          
			        category.setTooltip(g);
			        String catItem = category.getText().trim();
			        StringTokenizer stk = new StringTokenizer(catItem, "-");
			        for (int bb = 0; stk.hasMoreTokens(); bb++)
			        {  	catIns[catCount][bb] = new StringBuffer(stk.nextToken("-"));
			        }
			        catCount++;
			        category.setText("");
				}        	
        	}
        });  
        Button indatart = new Button("salva quesito");
        indatart.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	numbers = new String(catnumbers.getText().trim());
				if (numbers.length() == 0 || numbers == null)
				{	showAlert("Attenzione! Non hai digitato i numeri delle categorie!");					
				}
				else if (numbers.indexOf('-') == -1)
				{	showAlert("Attenzione! I numeri delle categorie devono essere separati da un trattino - !");					
				}
				else if(rtta.getSelectedText() == null || rtta.getSelectedText().length() == 0)
				{	showAlert("Attenzione! Non hai selezionato testo!");					
				}
				else
				{	if(catCount==0)
		        	{ 	if (domandert.size()==0)
		        		{   rtta.setText(rtta.getText().replaceAll("'","&#39;").replaceAll("\"","&#34;"));
		        		}
		        		domandert.add(new StringBuffer(rtta.getSelectedText().trim()));
		        	}
		        	else if(catCount!=0)
		        	{ 	domandert.add(new StringBuffer(rtta.getSelectedText().trim() + numbers.replaceAll("-","")));
		        	}
					rtta.replaceSelection("<span class=\"uline\" id='sp" + vectorcrt + "' >" +
			        rtta.getSelectedText().trim() + "</span>");
			        vectorcrt++;
			        catnumbers.setText("");
			        rtta.requestFocus();					
				}        	
        	}
        });  
        Button creart = new Button("crea il quiz");
        creart.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	getCheck();
        		if (check == false){}
				else if (domandert.size() == 0)
				{	showAlert("Attenzione! Prima di creare il quiz devi inserire domande e risposte!");
				}
				else				
				{	String htmlOpen = "";
					String script = "";
					String headbody = "";
					String tableOpen = "";
					String cat = "";
				    String opt = "";
				    String selClose = "";
				    String selection = "";
				    String cells = "";
				    String cells2 = "";
				    String risposte = "";
				    String pushr = "";
				    String varVarie = "";
				    String checkForm = "";
				    String correct="";
			        String error = "";
			        String check = "";
			        String clock = "";
			        String backup = rtta.getText();		  
			        drt = new StringBuffer[vectorcrt];
					domandert.copyInto(drt);
					String srt = "";
					if (nomeFile.getText().indexOf("RT")==-1)
					{ srt=nomeFile.getText()+"RT";
					}
					else
					{ srt=nomeFile.getText();
					}
					htmlOpen="<!DOCTYPE html>\n"+
    				"<html><head><title>" + srt + "</title>\n<meta charset=\"utf-8\">\n<style type=\"text/css\">\n<!--\n"+
					"* {font-family:"+fontType.getValue()+";background:"+bcolor+";color:"+fcolor+";font-size:"+fontSize.getValue()+"}"+
    				"td, caption {border-width:0px;padding:5px;border-radius:5px}\n"+
    				"input {background:"+fcolor+";color:"+bcolor+";border-radius:5px}\n"+
    				"input:focus {outline:none}\n"+
    				".bb {text-align:center}\n.boo {font-weight:bold}\n.uline {text-decoration:underline}\nA:link {text-decoration:none;color:blue}\n"+
    				"A:visited {text-decoration:none;color:blue}\nA:hover {text-decoration:underline;color:blue}\n"+
    				".borders{border-width:1px;border-color:gray;border-style:solid;text-align:center;width:33%;padding:10px;border-radius:5px" + 
    				"}"+"\n-->\n</style>\n";
				    script="<script src='" + srt + "/codice.js' type='text/javascript'></script>\n";
				    headbody="</head>\n<body onload=\"Clock()\">\n<form id=f1 name=f1 action=\"post\">\n";
				    tableOpen="<table style=\"width:99%\">\n<caption>" + intest.getText().trim() + "</caption>\n";				    
				    if (catCount != 0) 
				    { for (int bb = 0; bb < catCount; bb++) 
				      { cat="<select name='s" + bb + "' id='s" + bb + "' size='1'><option selected value='0'>\n";
				        for (int aa = 0; aa < catIns[bb].length; aa++) 
				        {   if (catIns[bb][aa] != null) 
				        	{ opt=opt+"<option value='" + (aa + 1) + "'>" + (aa + 1) + "." + catIns[bb][aa];
				            }
				        selClose="</select>\n<br><br>";
				        }
				        selection=selection+cat+opt+selClose;
				        opt="";
				      }
				    }	    
				    cells ="<tr>\n<td class=\"borders\">\n<span id = \"check\"><input type='button' value='controlla' onclick='check()'></span>\n<br><br>\n" + 
							"<span id=\"clock\" style=\"background:silver;color:red\">00:00:00</span></td>\n<td class=\"borders\">\n";
				    cells2="</td><td id='result' class=\"borders\">\nSeleziona la parola da classificare, le categorie, poi clicca su Controlla.\n"+
				    	    "</td>\n</tr>\n<tr>\n<td id=\"central\" colspan=\"3\">\n<br><br>" + 
				    		backup + "<br><br>\n</td>\n</tr><tr>\n<td colspan=\"3\" id='image' class=\"bb\">QuestionMark</td>\n</tr>\n</table>\n</form>\n</body>\n</html>";
				    String currentD=System.getProperty("user.dir");
				    frt = new File(currentD+"/quiz/"+srt);
				    frt.mkdir();
				    File frt_bag=new File(currentD+"/quiz/"+srt+"/"+srt);
				    frt_bag.mkdir();
				    try
					{   FileWriter fwCodRT = new FileWriter(frt_bag + "/codice.js");
				    	BufferedWriter bwCodRT = new BufferedWriter(fwCodRT);
				    	PrintWriter pwCodRT = new PrintWriter(bwCodRT);
				    	if (quizMedia.isSelected())
						try
							{		FileInputStream in1 = new FileInputStream(new File("audios/applause.wav"));
							        FileOutputStream out1 = new FileOutputStream(new File(frt_bag,"applause.wav"));
							        while (in1.available() != 0) 
							        { //finche' ci sono dati disponibili in input
							          out1.write(in1.read()); //leggi e scrivi
							        }
							        in1.close();
							        out1.close();
							        FileInputStream in2 = new FileInputStream(new File("audios/carbrake.wav"));
							        FileOutputStream out2 = new FileOutputStream(new File(frt_bag,"carbrake.wav"));
							        while (in2.available() != 0) 
							        { //finche' ci sono dati disponibili in input
							          out2.write(in2.read()); //leggi e scrivi
							        }
							        in2.close();
							        out2.close();
							        FileInputStream in3 = new FileInputStream(new File("imgs/images1.gif"));
							        FileOutputStream out3 = new FileOutputStream(new File(frt_bag,"images1.gif"));
							        while (in3.available() != 0) 
							        { //finche' ci sono dati disponibili in input
							          out3.write(in3.read()); //leggi e scrivi
							        }
							        in3.close();
							        out3.close();
							        FileInputStream in4 = new FileInputStream(new File("imgs/images2.gif"));
							        FileOutputStream out4 = new FileOutputStream(new File(frt_bag,"images2.gif"));
							        while (in4.available() != 0) 
							        {	//finche' ci sono dati disponibili in input
							        	out4.write(in4.read()); //leggi e scrivi
							        }
							        in4.close();
							        out4.close();
							}
						catch (Exception e) 
						{       System.out.println(e.toString());
				        }	    	
				    	String risEs = "var risEs = new Array();\n";
				    	for (int a = 0; a < vectorcrt; a++)
				        {        risEs= risEs + "risEs[" + a + "] = '" + drt[a] + "';\n";
				        }
				        risposte = "var r='';\n";
				        pushr = "function pushR()\n" + 
				        		"{	for(var m=0;m<" + catCount + ";m++)\n" + 
				        		"	{	var selNumb=document.getElementById('s'+m);\n" + 
				        		"		r = r+selNumb.options[selNumb.options.selectedIndex].index;\n" + 
				        		"	}\n" + 
				        		"}\n";     
				        varVarie = "var n = new Array();\n" + 
				        		"var a = 0;\n" + 
				        		"var esatte = 0;\n" + 
				        		"var errate = 0;\n" + 
				        		"var ink = new Array();\nink[0]=0;\n" + 
				        		"var ind = 0;\n" + 
				        		"var rValue=false;\n";
				        checkForm ="function checkForm()\n" + 
				        		"{   for (var h=0; h<" + catCount + "; h++)\n" + 
				        		"    {  var selectItem = document.getElementById('s'+h);\n" + 
				        		"       if (selectItem.options[selectItem.options.selectedIndex].index == 0)\n" + 
				        		"       {  	alert('Attenzione, non è stata selezionata una categoria!');\n" + 
				        		"			return false;\n " +
				        		"			eValue = false;\n" +			
				        		"       }\n" + 
					        	"    	else if(window.getSelection() == '')\n" + 
					        	"	    {  	alert('Attenzione, non hai selezionato testo!');\n" + 
					        	"			eValue = false;\n	"	+
					        	"			return false;\n" +
					        	"	    }\n" + 
				        		"    	else\n rValue=true;    \n" + 
				        		"    }\n" + 
				        		"}\n";			        
				        if (quizMedia.isSelected()==true)
				        {	correct = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
								"  	'<source src=\""+srt+"/applause.wav\" type=\"audio/ogg\">'+\n" + 
								"  	'<source src=\""+srt+"/applause.wav\" type=\"audio/mpeg\">'+\n" + 
								"	'Your browser does not support the audio element.</audio>'+\n" + 
								"	'<img src=\""+ srt + "/images1.gif\">';\n";
							error = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
									"'<source src=\""+srt+"/carbrake.wav\" type=\"audio/ogg\">'+\n" + 
									"'<source src=\""+srt+"/carbrake.wav\" type=\"audio/mpeg\">'+\n" + 
									"'Your browser does not support the audio element.</audio>'+\n" +
									"'<img src=\""+ srt + "/images2.gif\">';\n";
				        }
				        else
				        {	correct = "";
				        	error = "";
				        }
				        check = "function check()\n" + 
				        		"{   pushR();checkForm();\n" + 
				        		"    var indB=document.getElementById('sp'+ind);\n" + 
				        		"    var resultB=document.getElementById('result');\n" + 
				        		"    var CQB=document.getElementById('image');\n" + 
				        		"	 var risposte = new String(window.getSelection());\n" +
				        		"    risposte = risposte.trim() + r;\n" +
				        		"    if(esatte<risEs.length && rValue==true)\n" + 
				        		"    {	if(risEs[ind]==risposte)\n" + 
				        		"	    {	esatte++;indB.innerHTML='<span class=\"boo\">'+(ind+1)+'.'+risEs[ind].substring(0,risEs[ind].length-" + catCount + ")+'<\\/span>';\n" + 
				        		"	        ind++;\n" + 
				        					correct +
				        		"     \n}\n" +
				        		"	    else if(risEs[ind]!=risposte)\n" + 
				        		"	    {	errate++;n[errate]=ind+1;\n" + 
				        					error +
				        		"     \n}\n" +
				        		"    }\n" + 
				        		"    else if(esatte>=risEs.length)\n" + 
				        		"    {   document.getElementById('check').innerHTML = \"Test completato in \" + theclock.innerHTML;\n" +
				        		"        return false;\n" +
				        		"    }\n" + 
				        		"    var res = ((esatte-errate)/risEs.length);\n" + 
				        		"    var resS = res +'';\n" + 
				        		"    if (resS.indexOf('.')!=-1)\n" + 
				        		"    {   resS = resS.substring(0,resS.indexOf('.')+3);\n" + 
				        		"    }\n" + 
				        		"    var perc = esatte/(esatte+errate)*100+'';\n" + 
				        		"    if (perc.indexOf('.')!=-1)\n" + 
				        		"    {   perc = perc.substring(0,perc.indexOf('.')+3);\n" + 
				        		"    }\n" + 
	                            "	 var finalV = '';\n"+
						        "	 if (res<=1 && res>=0.9)\n"+
						        "	 finalV= resS+' OTTIMO (tra 0.9 e 1)';\n"+
						        "	 if (res<0.9 && res>=0.75)\n"+
						        "	 finalV= resS+' DISTINTO (tra 0.75 e 0.9)';\n"+
						        "	 else if (res<0.75 && res>=0.65)\n"+
						        "	 finalV=resS+' BUONO (tra 0.65 e 0.75)';\n"+
						        "	 else if (res<0.65 && res>=0.6)\n"+
						        "	 finalV=resS+' SUFFICIENTE (tra 0.6 e 0.65)';\n"+
						        "	 else if (res<0.6)\n"+
						        "	 finalV=resS+' NON SUFFICIENTE (minore di 0.6)';\n"+
				        		"    var punteggio='Risposte ' + esatte + ' su ' + risEs.length + ' in ' + theclock.innerHTML +'<br><span class=\"boo\">Esatte: '+esatte+'<br> Errate: '+errate+'<br>'+\n" + 
				        		"    'Percentuale: '+perc+'%<br> Valutazione finale: '+finalV+'<br> Sono state sbagliate le domande n.:';\n" + 
				        		"    var err = n.join(' ');\n" +
				        		"    resultB.style.textAlign = \"left\";\n" +
				        		"	 resultB.innerHTML=punteggio+err+'<\\/span>';\n" + 
				        		"    r = '';\n" +
				        		"}\n";
				        clock = "secs=0;\n" + 
				        		"mins=0;\n" + 
				        		"hours=0;\n" + 
				        		"function Clock()\n" + 
				        		"{   theclock=document.getElementById('clock');\n" + 
				        		"    secs++;\n" + 
				        		"    if (secs>=60)\n" + 
				        		"    {	secs=0;\n" + 
				        		"        mins++;\n" + 
				        		"        if (mins < 10) mins= '0' + mins;\n" + 
				        		"    }\n" + 
				        		"    else if(mins>=60)\n" + 
				        		"    {	mins=0;\n" + 
				        		"        hours++;\n" + 
				        		"        if(hours <10) hours='0'+hours;\n" + 
				        		"    }\n" + 
				        		"    if (secs < 10) \n" + 
				        		"    {   secs= '0' + secs;\n" + 
				        		"    }\n" + 
				        		"    theclock.innerHTML = hours + ':' + mins + ':' + secs;\n" + 
				        		"    window.setTimeout('Clock();',1000);\n" + 
				        		"}";
				        pwCodRT.println(risEs+risposte+pushr+varVarie+checkForm+check+clock);
				        pwCodRT.close();
				        bwCodRT.close();
				        fwCodRT.close();
				        /* Apri uno stream di input */
				    }
					catch (Exception e)
					{   System.out.println(e.toString());		
					}
					tp.setText(htmlOpen+script+headbody+tableOpen+cells+selection+cells2);
					//webengine.loadContent(tp.getText());
					if (nomeFile.getText().indexOf("RT") == -1)
					{	nomeFile.setText(nomeFile.getText()+"RT");
					}
					nomeFile.setEditable(false);
				}    	
        	}
        });
        Button resetrt = new Button("reset");
        resetrt.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	nomeFile.setText("");
				intest.setText("");
				category.setText("");
				catnumbers.setText("");
				messages.setText("");
				tp.setText("html");
				rtta.setText("");
				domandert.clear();
				category.setTooltip(new Tooltip(""));
				catCount=0;
				vectorcrt=0;
				bcolor = "";
				fcolor = ""; 	
				nomeFile.setEditable(true);
	       	}
        });
        AnchorPane aprt = new AnchorPane(category,incategory,rtta,catnumbers,indatart,creart,resetrt);
        AnchorPane.setTopAnchor(category,20.0);
        AnchorPane.setLeftAnchor(category,10.0);
        AnchorPane.setTopAnchor(incategory,20.0);
        AnchorPane.setLeftAnchor(incategory,300.0);
        AnchorPane.setTopAnchor(rtta,80.0);
        AnchorPane.setLeftAnchor(rtta,10.0);
        AnchorPane.setTopAnchor(catnumbers,240.0);
        AnchorPane.setLeftAnchor(catnumbers,10.0);
        AnchorPane.setTopAnchor(indatart,240.0);
        AnchorPane.setLeftAnchor(indatart,300.0);
        AnchorPane.setTopAnchor(creart,300.0);
        AnchorPane.setLeftAnchor(creart,10.0);
        AnchorPane.setTopAnchor(resetrt,300.0);
        AnchorPane.setLeftAnchor(resetrt,300.0);
        rttab.setContent(aprt);
        
        //START CR
        
        domandacr = new TextArea("");domandacr.setPromptText("domanda");
        domandacr.setWrapText(true);
        domandacr.setMaxWidth(200);
        domandacr.setMaxHeight(150);
        rispostacr = new TextArea("");rispostacr.setPromptText("risposta");
        rispostacr.setWrapText(true);
        rispostacr.setMaxWidth(200);
        rispostacr.setMaxHeight(150);
        Button indatacr = new Button("salva quesito");
        domandecr = new Vector<StringBuffer>();
        rispostecr = new Vector<StringBuffer>();
        indatacr.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	if (domandacr.getText().length() == 0 || domandacr.getText() == null)
				{	showAlert("Attenzione! Non hai digitato una domanda!");	
					domandacr.requestFocus();
				}
        		else if (rispostacr.getText().length() == 0 || rispostacr.getText() == null)
				{	showAlert("Attenzione! Non hai digitato una risposta!");					
				}
				else
				{	domandecr.add(new StringBuffer(domandacr.getText().replaceAll("'","").replaceAll("\"","")));
			        rispostecr.add(new StringBuffer(rispostacr.getText().replaceAll("'","").replaceAll("\"","")));
			        vectorccr++;
			        messages.setText("Domande: " + vectorccr);
			        domandacr.setText("");rispostacr.setText("");
				}    	
        	}
        });
        Button creacr = new Button("crea il quiz");
        creacr.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	getCheck();
        		if (check == false) {}
				else if (domandecr.size() == 0)
				{	showAlert("Attenzione! Prima di creare il quiz devi inserire domande e risposte!");
				}
				else if (rispostecr.size() == 0)
				{	showAlert("Attenzione! Prima di creare il quiz devi inserire domande e risposte!");
				}
				else				
				{	String sCR = "";
					if (nomeFile.getText().indexOf("CR")==-1)
					{ sCR=nomeFile.getText()+"CR";
					}
					else
					{ sCR=nomeFile.getText();
					}
					String h = "";
					String body ="";
					String textA = "";
					String footer ="";
					String cutnumbers = "";
					String evaluate = "";
					String pushr = "";
					String rises = "";
					String control = "";
					String check = "";
					String clock = "";
					String reg = "";
					String showit = "";
					h="<!DOCTYPE html>\n<html>\n<head><title>" + sCR + "</title>\n<meta charset=\"utf-8\">\n"
					    + "<style type=\"text/css\"> \n"
					    + " <!-- \n * {background:"+ bcolor + ";font-family:" + fontType.getValue() + ";"
					    + " font-size:" + fontSize.getValue() + ";color:" + fcolor + ";}\n"
					    + "input {background:" + fcolor + ";color: " + bcolor + ";padding: 5px;border-radius:5px}\n"
					    + "input:focus {outline:none}\n"
					    + ".nb {text-align: left; border: 1px solid " + fcolor + ";border-radius:5px;box-sizing: border-box; padding: 20px}\n" 
					    + ".nb2 {text-align: center; font-weight: bold; box-sizing: border-box; padding: 20px}\n"
					    + ".nb3 {}\n"
					    + ".grid-container {display: grid; grid-template-columns: 33% 33% 34%; grid-gap: 3px; box-sizing: border-box; padding: 2px;}\n"
					    + ".dropzone {border: 1px solid " + fcolor + ";border-radius:5px; padding:20px; cursor: move}\n"
					    + ".new {border: 3px solid " + fcolor + ";border-radius:5px;text-align: center; padding:20px;}\n"
					    + "-->\n</style> \n";
					body = "<script src='" + sCR + "/codice.js' type='text/javascript'></script>\n"
					    +"</head>\n<body onload=\"Clock()\">\n"
					    +"<div class = \"nb2\">" + intest.getText() + "</div>\n"
					    + "<div class = \"grid-container\">\n"
					    + "<div class = \"nb2\">domande - questions</div>\n"
					    + "<div class = \"nb2\">trascina qui - drag and drop here</div>\n"
					    + "<div class = \"nb2\">scegli una risposta - choose</div>\n";							    
					dcr = new StringBuffer[vectorccr];
			        domandecr.copyInto(dcr);
			        rcr = new StringBuffer[vectorccr];
			        rispostecr.copyInto(rcr);	
					dcr = new StringBuffer[vectorccr];
			        domandecr.copyInto(dcr);
			        rcr = new StringBuffer[vectorccr];
			        rispostecr.copyInto(rcr);			        
			        String currentD=System.getProperty("user.dir");
			        fcr = new File(currentD+"/quiz/"+sCR);
			        fcr.mkdir();
			        File fcr_bag=new File(currentD+"/quiz/"+sCR+"/"+sCR);
			        fcr_bag.mkdir();				        			        
			try {    FileWriter fwCodCR = new FileWriter(fcr_bag + "/codice.js");
				     BufferedWriter bwCodCR = new BufferedWriter(fwCodCR);
				     PrintWriter pwCodCR = new PrintWriter(bwCodCR);
				     cutnumbers = 
				     "function cutNumbers(n)\n" +
				     "{    var nS = n +'';\n" +
				     "     if (nS.indexOf('.')!=-1)\n" +
				     "     nS = nS.substring(0,nS.indexOf('.')+3); return nS;\n" +
				     "}\n";
				     evaluate = 
				     "function evaluate(h)\n"
				     +"{   if(h<=1 && h>=0.9)\n"
				     +"    return \"<b> ottimo - excellent (\" + cutNumbers(h) + \") 0.9 - 1</b>\";\n"
				     +"    else if(h<0.9 && h>=0.75)\n"
				     +"    return \"<b> distinto - very good (\" + cutNumbers(h) + \") 0.75 - 0.9</b>\";\n"
				     +"    else if(h<0.75 && h>0.65)\n"
				     +"    return \"<b> buono - good (\" + cutNumbers(h) + \") 0.65 - 0.75</b>\";\n"
				     +"    else if(h<=0.65 && h>=0.6)\n"
				     +"    return \"<b> sufficiente - adequate (\" + cutNumbers(h) + \") 0.6 - 0.65</b>\";\n"
				     +"    else if(h<0.6)\n"
				     +"    return \"<b> non sufficiente - not adequate (\" + cutNumbers(h) + \") meno di - less than 0.6</b>\";\n"
				     +"}\n";
				     pushr = 
				     "var esatte=0;\n" +
				     "var errate=0;\n" +
				     "var buttB=document.getElementById(\"butt\");\n" +
				     "var clockB=document.getElementById(\"clock\");\n" +
				     "var risEs = new Array();\n";
				     for (int d = 0; d < dcr.length; d++)
				     {    rises = rises + "risEs[" + d + "]='" + rcr[d] + "';\n";
				     }
				     control = 
				     "var exec = 0;\n"
				     +"function control()\n"
				     +"{   exec=0;\n"   
				     +"    for(var b = 0; b < risEs.length; b++)\n"
				     +"	   {   var sb = document.getElementById(\"d\"+b).innerHTML;\n"
				     +"        if (sb=='' || sb==null)\n"	        
				     +"        {\n"   
				     +"        }\n"
				     +"        else\n" 
				     +"        {   exec++;\n"            
				     +"        }\n"  
				     +"    }\n"
				     +"    return exec;\n"   
				     +"}\n";
				     check = 
				     "function check()\n"
    				 +"{   esatte = 0;\n"   
    				 +"    if (esatte < risEs.length)	\n"
    				 +"    {    for(var b = 0; b < risEs.length; b++)\n"
    				 +"		{ 	var sb = document.getElementById(\"d\"+b);\n"
    				 +"          var sx = document.getElementById(\"s\"+b);\n"
    				 +"          if (sb.innerHTML=='' || sb.innerHTML==null)\n"
    				 +"          {   alert(\"rispondi a tutte le domande! - complete the test!\");\n"
    				 +"              return false;\n"
    				 +"          }\n"
    				 +"          if(risEs[b]==sb.innerHTML)\n"
    				 +"		    {   esatte++;\n"
    				 +"              sb.setAttribute(\"draggable\", \"none\");\n"
    				 +"              sb.setAttribute(\"class\", \"new\");\n"
    				 +"              sx.setAttribute(\"draggable\", \"none\");\n"
    				 +"              sx.setAttribute(\"class\", \"nb3\");\n"
    				 +"			}\n"
    				 +"            else if (risEs[b] != sb.innerHTML)\n"
    				 +"		    {	errate++;\n"
    				 +"          }\n"
    				 +"        }\n"
    				 +"        var eser=\"giuste - correct: \"+esatte+\"<br>sbagliate - wrong: \"+errate+\"<br>\";\n"
    				 +"        var esito=evaluate((esatte-errate)/esatte)+\"<br>\";\n"
    				 +"        var perc='percent: '+cutNumbers(((esatte-errate)/esatte)*100)+'%<br>';\n"
    				 +"        var theCl = \"tempo - time: \"+Clock()+\"<br>\";\n"
    				 +"        var cqB=document.getElementById(\"cq\");\n"
    				 +"        cqB.innerHTML=eser+perc+esito+theCl;\n"
    				 +"    }\n"
    				 +"}\n";
				     clock =
				     "var secs=0;\n" +
				     "var mins=0;\n" +
				     "var hours=0;\n" +
				     "function Clock()\n" +
				     "{		var theclock=document.getElementById('clock');\n" +
				     "		secs++;\n" +
				     "		if (secs>=60)\n" +
				     "		{	secs=0;\n" +
				     "			mins++;\n" +
				     "			if (mins < 10)\n" +
				     "			mins= '0' + mins;\n" +
				     "		}\n" +
				     "		else if(mins>=60)\n" +
				     "		{	mins=0;\n" +
				     "			hours++;\n" +
				     "			if(hours <10)\n" +
				     "			hours='0'+hours;\n" +
				     "		}\n" +
				     "		if (secs < 10)\n" +
				     "		secs= '0' + secs;var theclockB=document.getElementById(\"theclock\");\n" +
				     "		theclock.innerHTML = hours + ':' + mins + ':' + secs;\n" +
				     "		window.setTimeout('Clock();',1000);\n" +
				     "		return theclock.innerHTML;\n" +
				     "}\n";
				     reg = 
				     "var dragged;\n"
				     + "/* events fired on the draggable target */\n"
				     + "document.addEventListener(\"drag\", function( event ) \n"
				     + "{  }, false);\n"
				     + "document.addEventListener(\"dragstart\", function( event ) \n"
				     + "{  // store a ref. on the dragged elem\n"
				     + "   dragged = event.target.innerHTML;\n"
				     + "   // make it half transparent\n"
				     + "   event.target.style.opacity = .5;\n"
				     + " \n"
				     + "}, false);\n"
				     + "document.addEventListener(\"dragend\", function( event ) \n"
				     + "{   // reset the transparency\n"
				     + "    event.target.style.opacity = \"\";\n"
				     + "    event.target.innerHTML = \"\";\n"
				     + "}, false);\n"
				     + "\n"
				     + "/* events fired on the drop targets */\n"
				     + "document.addEventListener(\"dragover\", function( event ) \n"
				     + "{   // prevent default to allow drop\n"
				     + "    event.preventDefault();\n"
				     + "}, false);\n"
				     + "document.addEventListener(\"dragenter\", function( event ) \n"
				     + "{   // highlight potential drop target when the draggable element enters it\n"
				     + "    if ( event.target.className == \"dropzone\" ) \n"
				     + "    {  event.target.style.background = \"\";\n"
				     + "    }\n"
				     + "}, false);\n"
				     + "document.addEventListener(\"dragleave\", function( event ) \n"
				     + "{   // reset background of potential drop target when the draggable element leaves it\n"
				     + "    if ( event.target.className == \"dropzone\" ) \n"
				     + "    {  event.target.style.background = \"\";\n"
				     + "    }\n"
				     + "}, false);\n"
				     + "document.addEventListener(\"drop\", function( event ) {\n"
				     + "    // prevent default action (open as link for some elements)\n"
				     + "    event.preventDefault();\n"
				     + "    // move dragged elem to the selected drop target\n"
				     + "    if ( event.target.className == \"dropzone\" ) \n"
				     + "    {   event.target.style.background = \"\";\n"
				     + "        event.target.innerHTML = dragged;\n"
				     + "    }    \n"
				     + "	else if (event.target.className != \"dropzone\")\n"
				     + "	{	location.reload();\n"
				     + "	}\n" 
				     + "  }, false);";
				     showit =
				     "function dragS ()\n"
				     + "{   event.dataTransfer.setData('text/plain',null);\n"
				     + "}\n";
				     pwCodCR.print(cutnumbers+evaluate+pushr+rises+control+check+clock+reg+showit);
				     pwCodCR.close();
				     bwCodCR.close();
				     fwCodCR.close();
				    }
					catch (Exception e) 
					{   System.out.println(e.toString());
					}
					String rCRsorted[] = new String[rcr.length];
				    for (int n = 0; n < rcr.length; n++) 
				    { rCRsorted[n] = new String(rcr[n]);
				    }
				    List<StringBuffer> strList = Arrays.asList(rcr);
			        Collections.shuffle(strList);
			        rcr = strList.toArray(new StringBuffer[strList.size()]);
				    for (int a = 0; a < vectorccr; a++) 
				    { textA = textA +
				    	"<div class = \"nb\">" + (a + 1) + "." + dcr[a] + "</div>\n" +
				    	"<div class = \"dropzone\"  id=\"d" + a + "\"  draggable = \"true\"></div>\n" +
				    	"<div class = \"dropzone\" id = \"s" + a + "\" ondragstart=\"javascript:dragS()\" draggable = \"true\">" + rcr[a] + "</div>\n";
				    }
				   footer = 
				   "<div class = \"nb2\" id = \"butt\">\n"
				   + "<input type=\"button\" value=\"controlla - check\" onclick=\"check()\">\n"
				   + "</div>\n"
				   + "<div class = \"nb2\" id = \"cq\">QuestionMark</div>\n"
				   + "<div class = \"nb2\" id = \"clock\">00:00:00</span>\n"
				   + "</div></div>\n"
				   + "</body>\n"
				   + "</html>";
				   tp.setText(h+body+textA+footer);
				   //webengine.loadContent(tp.getText());
				   if (nomeFile.getText().indexOf("CR") == -1)
					{	nomeFile.setText(nomeFile.getText()+"CR");
					}
				   nomeFile.setEditable(false);
				}    	
        	}
        });
        Button resetcr = new Button("reset");
        resetcr.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	nomeFile.setText("");
				intest.setText("");
				domandacr.setText("");
				rispostacr.setText("");
				messages.setText("");
				tp.setText("html");
				domandecr.clear();
				rispostecr.clear();
				vectorccr=0;
				bcolor = "";
				fcolor = "";
				nomeFile.setEditable(true);
        	}
        });
        AnchorPane apcr = new AnchorPane(domandacr,rispostacr,indatacr,creacr,resetcr);
        //positioning elements
        AnchorPane.setTopAnchor(domandacr,50.0);
        AnchorPane.setLeftAnchor(domandacr,10.0);
        AnchorPane.setTopAnchor(rispostacr,50.0);
        AnchorPane.setLeftAnchor(rispostacr,400.0);
        AnchorPane.setTopAnchor(indatacr,50.0);
        AnchorPane.setLeftAnchor(indatacr,250.0);
        AnchorPane.setTopAnchor(creacr,250.0);
        AnchorPane.setLeftAnchor(creacr,10.0);
        AnchorPane.setTopAnchor(resetcr,250.0);
        AnchorPane.setLeftAnchor(resetcr,400.0);
        crtab.setContent(apcr);        
        
        //START RF
        
        domandarf = new TextArea("");domandarf.setPromptText("frase in sequenza corretta");
        domandarf.setWrapText(true);
        domandarf.setMaxWidth(200);
        domandarf.setMaxHeight(150);
        rispostarf = new TextArea("");rispostarf.setPromptText("frase test");
        rispostarf.setWrapText(true);
        rispostarf.setMaxWidth(200);
        rispostarf.setMaxHeight(150);
        domanderf = new Vector<StringBuffer>();
        risposterf = new Vector<StringBuffer>();
        Button mix = new Button("frase test");
        mix.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	String g = domandarf.getText().trim().toLowerCase();
		    	String g2 = "";
		    	if (g == null || g.length() == 0)
		    	{	showAlert("Attenzione! Manca la frase!");				
				}
		    	else if (g.indexOf("frase in sequenza\ncorretta") != -1)
		    	{	showAlert("Attenzione! Manca la frase!");				
				}
		    	else if (g.indexOf(' ') == -1)
		    	{	showAlert("Attenzione! La frase non contiene spazi vuoti tra le parole, non può essere elaborata!");				
				}
		    	else if (g.indexOf("<br>") != -1 || g.indexOf("</") != -1)
		    	{	showAlert("Attenzione! Modificare lo stile del testo dopo aver creato la frase test!");				
				}
		    	else
		        {	StringTokenizer stk = new StringTokenizer(g," ");
			        Vector<StringBuffer> kappa = new Vector<StringBuffer>();
			        int kappaCount=0;
			        while (stk.hasMoreTokens())
			        {    kappa.add(new StringBuffer(stk.nextToken()));
			             kappaCount++;
			        }
			        order = new String[kappaCount];
			        for(int s=0; s<kappaCount; s++)
			        {	order[s]=new String(kappa.get(s));	        	
			        }
			        List<String> strList = Arrays.asList(order);
			        Collections.shuffle(strList);
			        order = strList.toArray(new String[strList.size()]);
			        for (int j = 0; j < order.length; j++)
			        {	g2 = g2 + " " + order[j];	        	
			        }
			        rispostarf.setText(g2.trim());
		        }    	
        	}
        });
        Button indatarf = new Button("salva quesito");
        indatarf.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	if (domandarf.getText() == null || domandarf.getText() == "")
				{	showAlert("Attenzione! Non hai inserito la frase in sequenza corretta!");				
				}
        		if (rispostarf.getText() == null || rispostarf.getText() == "")
				{	showAlert("Attenzione! Manca la frase per il test!");				
				}
        		else
				{  domanderf.add(new StringBuffer(domandarf.getText().toLowerCase().replaceAll("'","&#39;").replaceAll("\"","&#34;")));
				   risposterf.add(new StringBuffer(rispostarf.getText().trim().replaceAll("'","&#39;").replaceAll("\"","&#34;")));
			       vectorcrf++;
			       messages.setText("Domande: " + vectorcrf);
			       domandarf.setText("");rispostarf.setText("");
			    }    	
        	}
        });
        Button crearf = new Button("crea il quiz");
        crearf.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	getCheck();
        		if (check == false) {}
        		else if (domanderf.size() == 0)
				{	showAlert("Attenzione! Prima di creare il quiz devi inserire domande e risposte!");
				}
        		else if (risposterf.size() == 0)
				{	showAlert("Attenzione! Prima di creare il quiz devi inserire domande e risposte!");
				}
				else				
				{	String sRF="";
					if (nomeFile.getText().indexOf("RF")==-1)
					{ sRF=nomeFile.getText()+"RF";
					}
					else
					{ sRF=nomeFile.getText();
					}
					String htmlOpen = "";
					String css = "";
					String shbody = "";
					String divOpen = "";
					String cells = "";
					String frasi = "";
			        String frasiA = "";
			        String mixed = "";
			        String mixedA = "";
			        String varvarie = "";
			        String correct = "";
					String error = "" ;
					String pushr = "";
					String cutnumbers = "";
					String check = "";
					String evaluate = "";
					String nextph = "";
					String clock = "";
					if (quizMedia.isSelected())
					{	correct = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
						"  '<source src=\""+ sRF +"/applause.wav\" type=\"audio/ogg\">'+\n" + 
						"  '<source src=\""+ sRF +"/applause.wav\" type=\"audio/mpeg\">'+\n" + 
						"'Your browser does not support the audio element.</audio>'+\n" + 
						"'<img src=\""+ sRF + "/images1.gif\">';\n";
					error = "CQB.innerHTML='<audio controls autoplay hidden>'+\n" + 
							"'<source src=\""+ sRF +"/carbrake.wav\" type=\"audio/ogg\">'+\n" + 
							"'<source src=\""+ sRF +"/carbrake.wav\" type=\"audio/mpeg\">'+\n" + 
							"'Your browser does not support the audio element.</audio>'+\n" +
							"'<img src=\""+ sRF + "/images2.gif\">';\n";
					}
					else
					{	correct = "";
						error = "";
					}
					drf = new StringBuffer[vectorcrf];
			    	domanderf.copyInto(drf);
			    	rrf = new StringBuffer[vectorcrf];
			    	risposterf.copyInto(rrf);			    	
			    	String currentD=System.getProperty("user.dir");
			    	frf = new File(currentD+"/quiz/"+sRF);
			    	frf.mkdir();
			    	File frf_bag=new File(currentD+"/quiz/"+sRF+"/"+sRF);
			    	frf_bag.mkdir();	
			    	htmlOpen="<!DOCTYPE html>\n"+
			        "<html>\n<head>\n<title>" + sRF + "</title>\n<meta charset=\"utf-8\">\n";
			        css="<style type=\"text/css\">\n<!--\n"
	        		+ "* {font-family:" + fontType.getValue() + ";font-size: " + fontSize.getValue() + ";color:" + fcolor + "}\n"
					+ "body {background:" + bcolor + ";padding:5px;}\n"
			        + "textarea {font-family:" + fontType.getValue() + ";color: " + fcolor + ";font-size: " + fontSize.getValue() + "; text-align: center; padding: 10px}\n"
			        + "input {background:" + fcolor + ";font-family:" + fontType.getValue()+";color:" + bcolor + ";font-size: " + fontSize.getValue() + ";border-radius:5px}\n"
			        + "input:focus {outline:none}\n"
			        + ".uphead {position:absolute; top: 1%; left: 1%; width: 98%; height: 5%; text-align:center; padding: 2px}\n"
			        + ".upleft {position:absolute; top: 7%; left: 1%; width: 48%; height: 16%; overflow:auto; text-align:center; padding: 10px}\n"
			        + ".upright {position:absolute; top: 7%; left: 51%; width: 48%; height: 16%; overflow:auto; padding: 10px}\n"
			        + ".foo {position:absolute; top: 85%; left: 1%; width: 98%; height: 10%; overflow:auto; text-align:center; padding: 10px}\n"
					+ "-->\n</style>\n";
			        shbody = "<script src='" + sRF +  "/codice.js' type='text/javascript'></script>\n</head>\n"+
				     "<body onload=\"Clock()\">\n<form action=\"post\" id=\"f1\" name=\"f1\">\n";
				    divOpen="<div id = \"cap\" class = \"uphead\">" + intest.getText().trim() + "</div>\n"
			    		+ "<div id=\"result\" class=\"upleft\">\n"
			    		+ "Riordina la frase, poi clicca su Controlla<br>\n"
			    		+ "<br><input type='button' value='Controlla' onclick='check()'>\n"
			    		+ "<br><br><span id=\"clock\" style=\"background:silver;color:red\">00:00:00</span>\n"
			    		+ "</div>"
			    		+ "<div id = \"rispEs\" class=\"upright\">\n"
			    		+ "Risposte esatte: <br>Errate: <br> Percentuale: <br> Valutazione: <br> Domande sbagliate n.:\n"
			    		+ "</div>\n";			   			   
				    cells="<div id = \"central\" style = \"position: absolute; top: 25%; left: 1%; width: 97%; height: 50%; overflow: auto; text-align: center;  border: 1px solid gray; padding: 10px\">\n"
			    		+ "<br /><br /><br /><span id=\"mix\">" + rrf[0] + "</span>\n"
			    		+ "<br /><br /><br /><textarea id=\"ordered\" name=\"ordered\" rows=\"3\" cols=\"50\"></textarea>\n</div>"
			    		+ "<div id = \"CQ\" class = \"foo\">\nQuestionMark\n</div>\n"
			    		+ "</form>\n</body>\n</html>";			     
				     try
				     {	FileWriter fwCodRF = new FileWriter(frf_bag + "/codice.js");
					    BufferedWriter bwCodRF = new BufferedWriter(fwCodRF);
					    PrintWriter pwCodRF = new PrintWriter(bwCodRF);
					    frasi = "var frasi = new Array();\n";
					    for (int h=0;h<vectorcrf;h++)
					    {   frasiA = frasiA + "frasi["+h+"]=\""+drf[h]+"\";\n";
					    }
					    mixed = "var mixed = new Array();\n";
					    for (int k=0;k<vectorcrf;k++)
					    {   mixedA = mixedA + "mixed["+k+"]=\""+rrf[k]+"\";\n";
					    }
					     varvarie = "var index = 0;\n" +
				    	 "var risposta=\"\";\n" +
				    	 "var esatte = 0;\n" +
				    	 "var errate = 0;\n" +
				    	 "var errors = new Array();\n" +
				    	 "var secs=0;var mins=0; var hours=0;\n" +
				    	 "var esS=\"Risposte esatte: \";\n" +
				    	 "var erS=\"Errate: \";" +
				    	 "var percS = \"Percentuale: \";\n" +
				    	 "var valS = \"Valutazione: \";" +
				    	 "var sbS = \"Domande sbagliate n.: \";\n" +
				    	 "var brS = \"<br>\";";
					     cutnumbers = 
						     "function cutNumbers(n)\n" +
						     "{    var nS = n +'';\n" +
						     "     if (nS.indexOf('.')!=-1)\n" +
						     "     nS = nS.substring(0,nS.indexOf('.')+3); return nS;\n" +
						     "}\n";
					     pushr = "function pushR()\n"
				     		+ "{	risposta=document.f1.ordered.value;\n"
				     		+ "    for (a=0; a<risposta.length; a++)\n"
				     		+ "    {	if (risposta.charAt(a)=='\\'')\n"
				     		+ "          risposta=risposta.replace(/'/gi,\"&#39;\");\n"
				     		+ "	    else if (risposta.charAt(a)=='\\\"')\n"
				     		+ "          risposta=replace(/\"/gi,\"&#34;\");\n"
				     		+ "    }\n"
				     		+ "}\n";
					     check = "function check()\n"
				    		+ "{	pushR();\n"
				    		+ "		var CQB=document.getElementById(\"CQ\");\n"	
				     		+ "    if (esatte<(frasi.length-1))\n"
				     		+ "    {	if(risposta==frasi[index])\n"
				     		+ "        {	esatte++;\n"
				     		+ "        var CQB=document.getElementById(\"CQ\");\n"
				     		+          correct
				     		+ "        document.f1.ordered.value=\"\";document.f1.ordered.focus();\n"
				     		+ "        nextPh();\n"
				     		+ "        }\n"
				     		+ "        else\n"
				     		+ "        {	errate++;\n"
				     		+ "            var CQB=document.getElementById(\"CQ\");\n"
				     		+ 			error           
				     		+ "            errors[index]=index+1;\n"
				     		+ "        }\n"
				     		+ "    }\n"
				     		+ "    else if (esatte>=(frasi.length-1))\n"
				     		+ "    {	if(risposta==frasi[index])\n"
				     		+ "        {	esatte++;\n"
				     		+ "            var CQB=document.getElementById(\"CQ\");\n"
				     		+              correct
				     		+ "            var resultB=document.getElementById(\"result\");\n"
				     		+ "            var clockB=document.getElementById(\"clock\");\n"
				     		+ "            resultB.innerHTML=\"TEST COMPLETATO IN \"+clockB.innerHTML;\n"
				     		+ "        }\n"
				     		+ "        else\n"
				     		+ "            {	errate++;\n"
				     		+                 	error
				     		+ "                	errors[index]=index+1;\n"
				     		+ "            }\n"
				     		+ "      }\n"
				     		+ "      Evaluate();\n"
				     		+ "}\n";
					     evaluate = "function Evaluate()\n"
				    		+ "{   var perc = esatte/(esatte+errate)*100+'%';\n"
				    		+ "    if (perc.indexOf('.')!=-1)\n"
				    		+ "    {   perc = perc.substring(0,perc.indexOf('.')+2)+'%';\n"
				    		+ "    }\n"
				    		+ "    var val = cutNumbers((esatte-errate)/esatte);\n"
				    		+ "    var valT=\"\";\n"
				    		+ "    if(val<=1 && val>=0.9) \n"
				    		+ "    {   valT=\"<span class='boo'>\" + val + \" Ottimo (tra 0.9 e 1)<\\/span>\";\n"
				    		+ "    }\n"
				    		+ "    else if (val<0.9 && val>0.75) \n"
				    		+ "    {   valT=\"<span class='boo'>\" + val + \" Distinto (tra 0.9 e 0.75)<\\/span>\";\n"
				    		+ "    }\n"
				    		+ "    else if (val<=7.5 && val>0.65) \n"
				    		+ "    {   valT=\"<span class='boo'>\" + val + \" Buono (tra 0.75 e 0.65) <\\/span>\";\n"
				    		+ "    }\n"
				    		+ "    else if (val<=0.65 && val>=0.6) \n"
				    		+ "    {   valT=\"<span class='boo'>\" + val + \" Sufficiente (tra 0.65 e 0.6)<\\/span>\";\n"
				    		+ "    }\n"
				    		+ "    else if (val<0.6)\n"
				    		+ "    {   valT=\"<span class='boo'>\" + val + \" Non sufficiente (minore di 0.6)<\\/span>\";\n"
				    		+ "    }\n"
				    		+ "    var rispEsB=document.getElementById(\"rispEs\");\n"
				    		+ "    rispEsB.innerHTML=esS+esatte+brS+erS+errate+brS+percS+perc+brS+valS+valT+brS+sbS+errors.join(\"-\");\n"
				    		+ "}\n";
					     nextph = "function nextPh()\n"
				    		+ "{   index++;\n"
				    		+ "    var mixB = document.getElementById(\"mix\");\n"
				    		+ "    mixB.innerHTML=mixed[index];\n"
				    		+ "    document.f1.ordered.focus();\n"
				    		+ "}";
					     clock = "function Clock()\n"
				    		+ "{   theclock=document.getElementById('clock');\n"
				    		+ "    secs++;\n"
				    		+ "    if (secs>=60)\n"
				    		+ "    {	secs=0;\n"
				    		+ "        mins++;\n"
				    		+ "        if (mins < 10) mins= '0' + mins;\n"
				    		+ "    }\n"
				    		+ "    else if(mins>=60)\n"
				    		+ "    {	mins=0;\n"
				    		+ "        hours++;\n"
				    		+ "        if(hours <10) hours='0'+hours;\n"
				    		+ "    }\n"
				    		+ "    if (secs < 10) \n"
				    		+ "    {   secs= '0' + secs;\n"
				    		+ "    }\n"
				    		+ "    theclock.innerHTML = hours + ':' + mins + ':' + secs;\n"
				    		+ "    window.setTimeout('Clock();',1000);\n"
				    		+ "}";
				     pwCodRF.print(frasi+frasiA+mixed+mixedA+varvarie+pushr+cutnumbers+check+evaluate+nextph+clock);
				     pwCodRF.close();
				     bwCodRF.close();
				     fwCodRF.close();
				     if (quizMedia.isSelected() == true)
					 {	/* Apri uno stream di input */
					     FileInputStream in1 = new FileInputStream(new File("audios/applause.wav"));
					     /* Apri uno stream di output */
					     FileOutputStream out1 = new FileOutputStream(new File(frf_bag,"applause.wav"));
					     while (in1.available() != 0) {
					     //finche' ci sono dati disponibili in input
					     out1.write(in1.read()); //leggi e scrivi
					     }
					     in1.close();
					     out1.close();
					     FileInputStream in2 = new FileInputStream(new File("audios/carbrake.wav"));
					     FileOutputStream out2 = new FileOutputStream(new File(frf_bag,"carbrake.wav"));
					     while (in2.available() != 0)
					     { //finche' ci sono dati disponibili in input
					     out2.write(in2.read()); //leggi e scrivi
					     /* Chiudi i due stream */
					     }
					     in2.close();
					     out2.close();
					     FileInputStream in3 = new FileInputStream(new File("imgs/images1.gif"));
					     FileOutputStream out3 = new FileOutputStream(new File(frf_bag,"images1.gif"));
					     while (in3.available() != 0)
					     { //finche' ci sono dati disponibili in input
					       out3.write(in3.read()); //leggi e scrivi
					       /* Chiudi i due stream */
					     }
					     in3.close();
					     out3.close();
					     FileInputStream in4 = new FileInputStream(new File("imgs/images2.gif"));
					     FileOutputStream out4 = new FileOutputStream(new File(frf_bag,"images2.gif"));
					     while (in4.available() != 0)
					     { //finche' ci sono dati disponibili in input
					       out4.write(in4.read()); //leggi e scrivi
					       /* Chiudi i due stream */
					     }
					     in4.close();
					     out4.close();
					     }
				     }
				     catch (Exception e)
				     {	System.out.println(e.toString());    	 
				     }
				     tp.setText(htmlOpen+css+shbody+divOpen+cells);
				     //webengine.loadContent(tp.getText());
				     if (nomeFile.getText().indexOf("RF") == -1)
						{	nomeFile.setText(nomeFile.getText()+"RF");
						}
				     nomeFile.setEditable(false);
				}  	
        	}
        });
        Button resetrf = new Button("reset");
        resetrf.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{	nomeFile.setText("");
				intest.setText("");
				domandarf.setText("");
				rispostarf.setText("");
				messages.setText("");
				tp.setText("html");
				vectorcrf=0;
				bcolor = "";
				fcolor = "";  
				nomeFile.setEditable(true);
        	}
        });
        AnchorPane aprf = new AnchorPane(domandarf,rispostarf,mix,indatarf,crearf,resetrf);
        //positioning elements
        AnchorPane.setTopAnchor(domandarf,50.0);
        AnchorPane.setLeftAnchor(domandarf,10.0);
        AnchorPane.setTopAnchor(rispostarf,50.0);
        AnchorPane.setLeftAnchor(rispostarf,400.0);
        AnchorPane.setTopAnchor(mix,50.0);
        AnchorPane.setLeftAnchor(mix,250.0);
        AnchorPane.setTopAnchor(indatarf,100.0);
        AnchorPane.setLeftAnchor(indatarf,250.0);
        AnchorPane.setTopAnchor(crearf,250.0);
        AnchorPane.setLeftAnchor(crearf,10.0);
        AnchorPane.setTopAnchor(resetrf,250.0);
        AnchorPane.setLeftAnchor(resetrf,400.0);
        rftab.setContent(aprf);        
        
        //ADDING TO ROOT 
              
        root.add(menuBar,0,0,4,1);
        root.add(bglabel,5,0,3,1);
        root.add(undolabel,13,0,3,1);
        root.add(redolabel,16,0,4,1);
        root.add(nomeFile, 0,2,2,1); 
        root.add(backColor,3,2,2,1);
        root.add(quizMedia,5,2,2,1);
        root.add(fontType,0,4,2,1);        
        root.add(fontSize,3,4,2,1);
        root.add(fontColor,5,4,2,1);        
        root.add(intest,0,6,2,2);
        root.add(titolo,3,6,4,2);
        root.add(stile,5,6,6,2);        
        root.add(htpane,8,2,13,16);
        root.add(view1,2,8,4,2);
        root.add(tab,0,10,7,9);
        root.add(messages,5,19,10,1);
        javafx.geometry.Rectangle2D primaryScreenBounds = Screen.getPrimary().getVisualBounds();
        Scene scene = new Scene(root,primaryScreenBounds.getWidth(),primaryScreenBounds.getHeight());
        primaryStage.setScene(scene);
        primaryStage.sizeToScene();
        scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
        primaryStage.show();        
     }
    public void showAlert(String b)
    {	Alert alert = new Alert(AlertType.WARNING);
		alert.setTitle("Attenzione!");
		alert.setHeaderText(null);
		alert.setContentText(b);
		alert.showAndWait();    	
    }    
    public boolean getCheck()
	{	if (nomeFile.getText() == null || nomeFile.getText().length() == 0)
		{	showAlert("Scegli un nome file!");
			nomeFile.requestFocus();
			nomeFile.selectAll();
			check = false;
		}
		else if (nomeFile.getText().indexOf("nome file") != -1 || nomeFile.getText().length() == 9)
		{	showAlert("Scegli un nome file!");
			nomeFile.requestFocus();
			nomeFile.selectAll();
			check = false;
		}
		else if (bcolor == "" || fcolor == "")
		{	showAlert("Non hai selezionato un colore per lo sfondo o per il font!");
			check = false;
		}
		else if (fontType.getValue() == null || fontSize.getValue() == null)
		{	showAlert("Scegli un font e la sua dimensione!");
		    check = false;
		}
		else if (intest.getText() == null || intest.getText().length() == 0)
		{	showAlert("Scegli un' intestazione per il quiz!");
			intest.requestFocus();
			intest.selectAll();
			check = false;
		}
		else if (intest.getText().indexOf("intestazione")!= -1 || intest.getText().length() == 12)
		{	showAlert("Scegli un' intestazione per il quiz diversa da ' intestazione'!");
			intest.requestFocus();
			intest.selectAll();
			check = false;
		}
		else
		{ 	check = true;
		}
		return check;
}  
class bcolorPicker extends Application 
{   @Override
    public void start(Stage stage) 
	{   ColorPicker colorPicker = new ColorPicker();
        colorPicker.setValue(Color.WHITE); 
        final Circle circle = new Circle(50);
        circle.setFill(colorPicker.getValue()); 
        colorPicker.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{   circle.setFill(colorPicker.getValue());
	        	b = "" + colorPicker.getValue();
	    		b = b.substring(2);
	    		b = "#" + b.substring(0,b.length()-2);   
            }
        }); 
        Button getCol = new Button("Seleziona questo colore");
        getCol.setPrefWidth(200);
        getCol.setOnAction(new EventHandler<ActionEvent>()
        {	@Override
			public void handle(ActionEvent arg0) 
			{ 	bcolor=b;
        		stage.close();			
			}
	    });        
        AnchorPane root= new AnchorPane(circle, colorPicker,getCol);
        root.getStyleClass().add("main-root");
        root.setPadding(new Insets(10));
        //root.setHgap(10);
        AnchorPane.setLeftAnchor(circle, 0.0);
        AnchorPane.setTopAnchor(circle, 10.0);
        AnchorPane.setLeftAnchor(colorPicker, 150.0);
        AnchorPane.setTopAnchor(colorPicker, 30.0);
        AnchorPane.setLeftAnchor(getCol, 50.0);
        AnchorPane.setTopAnchor(getCol, 200.0);
        Scene scene = new Scene(root, 400, 300); 
        scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
        stage.setTitle("QuestionMark pannello colori dello sfondo"); 
        stage.setScene(scene);
        stage.show();
    } 
}
class fcolorPicker extends Application 
{   @Override
    public void start(Stage stage) 
	{   ColorPicker colorPicker = new ColorPicker();
        colorPicker.setValue(Color.WHITE); 
        final Circle circle = new Circle(50);
        circle.setFill(colorPicker.getValue()); 
        colorPicker.setOnAction(new EventHandler<ActionEvent>() 
        {   @Override
            public void handle(ActionEvent event) 
        	{   circle.setFill(colorPicker.getValue());
	        	f = "" + colorPicker.getValue();
	    		f = f.substring(2);
	    		f = "#" + f.substring(0,f.length()-2);   
            }
        }); 
        Button getCol = new Button("Seleziona questo colore");
        getCol.setPrefWidth(200);
        getCol.setOnAction(new EventHandler<ActionEvent>()
        {	@Override
			public void handle(ActionEvent arg0) 
			{ 	fcolor=f;
        		stage.close();			
			}
	    });        
        AnchorPane root= new AnchorPane(circle, colorPicker,getCol);
        root.getStyleClass().add("main-root");
        root.setPadding(new Insets(10));
        AnchorPane.setLeftAnchor(circle, 0.0);
        AnchorPane.setTopAnchor(circle, 10.0);
        AnchorPane.setLeftAnchor(colorPicker, 150.0);
        AnchorPane.setTopAnchor(colorPicker, 30.0);
        AnchorPane.setLeftAnchor(getCol, 50.0);
        AnchorPane.setTopAnchor(getCol, 200.0);
        Scene scene = new Scene(root, 400, 300); 
        scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
        stage.setTitle("QuestionMark pannello colori del font"); 
        stage.setScene(scene);
        stage.show();
    } 
  }
}